/*	Filename:FileInfo.cpp						*/
/************************************************/
/*												*/
/*			tt@CNX				*/
/*												*/
/*				For DSMP File.Inf				*/
/*												*/
/*					Ver.1.211  					*/
/*												*/
/*		Copyright 1997,1999 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "FindFile.h"
#include "FileInfo.h"

#pragma package(smart_init)

#ifndef	then
#define	then
#endif
#ifndef	AND
#define	AND	&&
#endif
#ifndef	OR
#define	OR	||
#endif

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

AnsiString	DSMPPath;
UINT		WM_DSMP;

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

AnsiString __fastcall	GetDSMPPath(void)
{
	DSMPPath="";
	TRegistry	*Reg=new TRegistry();
	Reg->RootKey=HKEY_LOCAL_MACHINE;
	if (Reg->OpenKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DSMP.EXE",false))
	then {
		try {
			DSMPPath=Reg->ReadString("");
		}
		catch(...)
		{
			DSMPPath="";
		}
		Reg->CloseKey();
	}

	if (DSMPPath.IsEmpty())
	then {
		Reg->RootKey=HKEY_CURRENT_USER;
		if (Reg->OpenKey("Software\\DELTA\\DSMP",false))
		then {
			try {
				DSMPPath=Reg->ReadString("");
			}
			catch(...)
			{
				DSMPPath="";
			}
			Reg->CloseKey();
		}
	}
	delete	Reg;

	WM_DSMP=::RegisterWindowMessage("WM_DSMP");				//WM_DSMP擾

	return(DSMPPath);
}

/*****	΃pXւ̕ϊ	*****/

AnsiString __fastcall	AbsPath(AnsiString Path,AnsiString BasePath)
{
	if ((!Path.IsEmpty()) AND (!BasePath.IsEmpty()))
	then {
		AnsiString	CurDir=GetCurrentDir();
		SetCurrentDir(BasePath);
		Path=ExpandFileName(Path);							//΃pX̎擾
		SetCurrentDir(CurDir);
	}

	return(Path);
}

/*****	΃pX֕ϊ	*****/

AnsiString __fastcall	RelativePath(AnsiString Path,AnsiString BasePath)
{
	if ((!Path.IsEmpty()) AND (!BasePath.IsEmpty()))
	then {
		Path=AbsPath(Path,BasePath);						//΃pX
		Path=ExtractRelativePath(BasePath+"\\",Path);	 	//΃pXɕϊ
	}

	return(Path);
}

/*****	WindowsfBNg擾	*****/

AnsiString __fastcall	GetWindowsDir(void)
{
	char	bf[MAX_PATH+1];

	::GetWindowsDirectory(bf,MAX_PATH+1);
	return((AnsiString)bf);
}

/*****	Windows SystemfBNg擾	*****/

AnsiString __fastcall	GetSystemDir(void)
{
	char	bf[MAX_PATH+1];

	::GetSystemDirectory(bf,MAX_PATH+1);
	return((AnsiString)bf);
}

/*****	FILE.INF̍폜	*****/

void __fastcall	DeleteFileInf(void)
{
	AnsiString	S=ExtractFileDir(DSMPPath);
	S+="\\FILE*.INF";

	TFindFile	Find(S);

	while(Find.Find())
	{
		DeleteFile(Find.Path);
	}
}

/*----------------------------------------------*/
/*				TPlayInfoNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TPlayInfo::TPlayInfo(void)
{
	Section="Title";
}

/*****	RXgN^	*****/

__fastcall	TPlayInfo::TPlayInfo(AnsiString name)
{
	Section="Title";
	Read(name);
}

/*****	tt@Č	*****/

int __fastcall	TPlayInfo::FindInfFile(void)
{
	TIniFile	*File;
	AnsiString	S=ExtractFileDir(DSMPPath);
	S+="\\FILE*.INF";

	TFindFile	Find(S);
	while(Find.Find())
	{
		S=Find.Path;
		File=new TIniFile(S);
		if (File->ValueExists(Section,Name))
		then {
			delete	File;

			S=ExtractFileName(S);
			S=S.LowerCase();
			int		n1=S.AnsiPos("file")+4;
			int		n2=S.AnsiPos(".");
			S=S.SubString(n1,n2-n1);
			FInfNo=S.ToIntDef(-1);
			return(FInfNo);
		}
		else	delete	File;
	}

	return(-1);
}

/*****	Inft@CpX̎擾	*****/

AnsiString __fastcall	TPlayInfo::GetPath(void)
{
	if (FInfNo<0)
	then	return("");

	AnsiString	S=ExtractFileDir(DSMPPath);
	S+="\\FILE";
	S+=FInfNo;
	S+=".INF";

	return(S);
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TPlayInfo::Read(AnsiString name)
{
	FName=name;

	if (FindInfFile()<0)
	then {
		FTitle="";
		return("");
	}

	TIniFile	*File=new TIniFile(Path);

	FTitle=File->ReadString(Section,Name,"");

	delete	File;

	return(FTitle);
}

/*****	t@C̓o^	*****/

void __fastcall	TPlayInfo::WriteValue(AnsiString Value)
{
	AnsiString	S;

	if (FInfNo<0)									//o^̏ꍇ
	then {
		S=ExtractFileDir(DSMPPath);
		S+="\\FILE*.INF";
		TFindFile	Find(S);
		while(Find.Find())
		{
			if (Find.FileSizeLow<48128)				//48K̃t@Cg
			then {
				S=ExtractFileName(Find.Path);
				S=S.LowerCase();
				int		n1=S.AnsiPos("file")+4;
				int		n2=S.AnsiPos(".");
				S=S.SubString(n1,n2-n1);
				FInfNo=S.ToIntDef(-1);
				break;
			}
		}
		if (FInfNo<0)								//48K̃t@CȂꍇ͐VK쐬
		then {
			FInfNo=-1;
			do {
				FInfNo++;
				S=ExtractFileDir(DSMPPath);
				S+="\\FILE";
				S+=FInfNo;
				S+=".INF";
			} while(FileExists(S)==true);		//łɂꍇ͎̔ԍ
		}
	}
	TIniFile	*File=new TIniFile(Path);

	File->WriteString(Section,Name,Value);		//t@C֓o^
	File->UpdateFile();							//t@CTCYXV̈

	delete	File;
}

/*****	t@C̓o^	*****/

void __fastcall	TPlayInfo::Write(void)
{
	WriteValue(Title);
}

/*****	t@C̍폜	*****/

void __fastcall	TPlayInfo::Delete(void)
{
	if (FInfNo<0)
	then	return;

	TIniFile	*File=new TIniFile(Path);

	File->DeleteKey(Section,Name);

	delete	File;
}

/*----------------------------------------------*/
/*				TPlayFileInfoNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TPlayFileInfo::TPlayFileInfo(void)
:TPlayInfo()
{
	Section="File";
}

/*****	RXgN^	*****/

__fastcall	TPlayFileInfo::TPlayFileInfo(AnsiString name)
:TPlayInfo()
{
	Section="File";
	Read(name);
}

/*****	J}eLXg̎擾	*****/

AnsiString __fastcall	TPlayFileInfo::GetCommaText(void)
{
	TStringList	*SList=new TStringList();

	SList->Add(Title);
	SList->Add(Artist);
	SList->Add(Length);
	SList->Add(Lyrics);
	if (CD)
	then	SList->Add(CD);
	else	SList->Add("");
	if (Track)
	then	SList->Add(Track);
	else	SList->Add("");
	SList->Add(AdjustLyrics);
	SList->Add(Time);

	AnsiString	S=SList->CommaText;

	delete	SList;

	return(S);
}

/*****	J}eLXg̐ݒ	*****/

void __fastcall	TPlayFileInfo::SetCommaText(AnsiString S)
{
	TStringList	*SList=new TStringList();

	SList->CommaText=S;
	while(SList->Count<8)
	{
		SList->Add("");
	}

	Title=SList->Strings[0];
	Artist=SList->Strings[1];
	Length=SList->Strings[2].ToIntDef(0);
	Lyrics=SList->Strings[3];
	CD=SList->Strings[4].ToIntDef(0);
	Track=SList->Strings[5].ToIntDef(0);
	AdjustLyrics=SList->Strings[6].ToIntDef(0);
	Time=SList->Strings[7].ToIntDef(0);

	delete	SList;
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TPlayFileInfo::Read(AnsiString name)
{
	AnsiString	S=inherited::Read(name);

	SetCommaText(S);

	return(S);
}

/*****	t@C̓o^	*****/

void __fastcall	TPlayFileInfo::Write(void)
{
	TStringList	*SList=new TStringList();

	SList->Add(Title);
	SList->Add(Artist);
	SList->Add(Length);
	SList->Add(Lyrics);
	if (CD)
	then	SList->Add(CD);
	else	SList->Add("");
	if (Track)
	then	SList->Add(Track);
	else	SList->Add("");
	SList->Add(AdjustLyrics);

	AnsiString	S=SList->CommaText;

	WriteValue(S);

	delete	SList;
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TPlayFileInfo::GetFileName(void)
{
	AnsiString	S=Name;
	int	n=S.AnsiPos(":");
	if (n)
	then	S=S.SubString(n+1,S.Length()-n);

	return(S);
}

/*****	t@C̐ݒ	*****/

void __fastcall	TPlayFileInfo::SetFileName(AnsiString filename)
{
	if (Length)
	then {
		Name=Length;
		Name+=":";
		Name+=filename;
	}
	else	Name=filename;
}

/*----------------------------------------------*/
/*				TCDListNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TCDList::TCDList(void)
{
	FList=new TList();
}

/*****	fXgN^	*****/

__fastcall	TCDList::~TCDList(void)
{
	delete	FList;
}

/*****	ACe̎擾	*****/

TPlayInfo* __fastcall	TCDList::GetItem(int Index)
{
	return((TPlayInfo*)FList->Items[Index]);
}

/*****	ACe̐ݒ	*****/

void __fastcall	TCDList::SetItem(int Index,TPlayInfo *Info)
{
	FList->Items[Index]=Info;
}

/*****	Xg̃CfbNX擾	*****/

int __fastcall	TCDList::IndexOf(int Length)
{
	int			i;
	AnsiString	S=Length;

	for(i=0;	i<FList->Count;	i++)
	{
		if (((TPlayInfo*)(FList->Items[i]))->Name==S)
		then	return(i);
	}

	return(-1);
}

/*****	CD̎擾	*****/

TPlayInfo* __fastcall	TCDList::GetInfo(int Length)
{
	int		n=IndexOf(Length);

	if (n<0)
	then	return(NULL);

	return((TPlayInfo*)(FList->Items[n]));
}

/*****	CD^Cg̎擾	*****/

AnsiString __fastcall	TCDList::GetTitle(int Length)
{
	TPlayInfo	*Info=GetInfo(Length);

	if (Info)
	then	return(Info->Title);

	return("");
}

/*****	CD^Cg̐ݒ	*****/

void __fastcall	TCDList::SetTitle(int Length,AnsiString Title)
{
	TPlayInfo	*Info=GetInfo(Length);

	if (Info)
	then	Info->Title=Title;
}

/*****	Xg̃NA	*****/

void __fastcall	TCDList::Clear(void)
{
	int			i;

	for(i=0;	i<FList->Count;	i++)
	{
		delete	GetItem(i);
	}
	FList->Clear();
}

/*****	Xgƃt@C폜	*****/

void __fastcall	TCDList::Delete(int Index)
{
	if ((Index>=0) AND (Index<FList->Count))
	then {
		TPlayInfo	*Info=GetItem(Index);
		Info->Delete();
		delete	Info;
		FList->Delete(Index);
	}
}

/*****	t@C烍[h	*****/

void __fastcall	TCDList::Load(void)
{
	int			i;
	TStringList	*SList=new TStringList();
	TIniFile	*File;
	AnsiString	S=ExtractFileDir(DSMPPath);
	S+="\\FILE*.INF";

	TFindFile	Find(S);

	while(Find.Find())
	{
		File=new TIniFile(Find.Path);
		File->ReadSection("Title",SList);
		for(i=0;	i<SList->Count;	i++)
		{
			Add(new TPlayInfo(SList->Strings[i]));
		}
		delete	File;
		Application->ProcessMessages();
	}
	delete	SList;
}

/*****	t@CփZ[u	*****/

void __fastcall	TCDList::Save(void)
{
	int		i;

	for(i=0;	i<FList->Count;	i++)
	{
		((TPlayInfo*)(FList->Items[i]))->Write();
	}
}

/*----------------------------------------------*/
/*				TFileListNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TFileList::TFileList(void)
{
	FList=new TList();
}

/*****	fXgN^	*****/

__fastcall	TFileList::~TFileList(void)
{
	delete	FList;
}

/*****	ACe̎擾	*****/

TPlayFileInfo* __fastcall	TFileList::GetItem(int Index)
{
	return((TPlayFileInfo*)FList->Items[Index]);
}

/*****	ACe̐ݒ	*****/

void __fastcall	TFileList::SetItem(int Index,TPlayFileInfo *Info)
{
	FList->Items[Index]=Info;
}

/*****	Xg̃CfbNX擾	*****/

int __fastcall	TFileList::IndexOf(AnsiString Name)
{
	int		i;

	for(i=0;	i<FList->Count;	i++)
	{
		if (((TPlayFileInfo*)(FList->Items[i]))->Name==Name)
		then	return(i);
	}
	return(-1);
}

/*****	t@C̎擾	*****/

TPlayFileInfo* __fastcall	TFileList::GetInfo(AnsiString Name)
{
	int		n=IndexOf(Name);

	if (n<0)
	then	return(NULL);

	return((TPlayFileInfo*)(FList->Items[n]));
}

/*****	Xg̃NA	*****/

void __fastcall	TFileList::Clear(void)
{
	int			i;

	for(i=0;	i<FList->Count;	i++)
	{
		Delete(i);
	}
	FList->Clear();
}

/*****	Xgƃt@C폜	*****/

void __fastcall	TFileList::Delete(int Index)
{
	if ((Index>=0) AND (Index<FList->Count))
	then {
		TPlayFileInfo	*Info=GetItem(Index);
		Info->Delete();
		delete	Info;
		FList->Delete(Index);
	}
}

/*****	Xgƃt@C폜	*****/

void __fastcall	TFileList::Delete(AnsiString Name)
{
	Delete(IndexOf(Name));
}

/*****	t@C烍[h	*****/

void __fastcall	TFileList::Load(void)
{
	int			i,n,n1,n2;
	TStringList	*SList=new TStringList();
	TPlayFileInfo	*Info;
	TIniFile	*File;
	AnsiString	S=ExtractFileDir(DSMPPath);
	S+="\\FILE*.INF";

	TFindFile	Find(S);

	while(Find.Find())
	{
		S=ExtractFileName(Find.Path);
		S=S.LowerCase();
		n1=S.AnsiPos("file")+4;
		n2=S.AnsiPos(".");
		S=S.SubString(n1,n2-n1);
		n=S.ToIntDef(-1);

		File=new TIniFile(Find.Path);
		File->ReadSection("File",SList);
		for(i=0;	i<SList->Count;	i++)
		{
//			Add(new TPlayFileInfo(SList->Strings[i]));				//Pȕ@Ałx

			Info=new TPlayFileInfo();
			Info->InfNo=n;
			Info->Name=SList->Strings[i];
			Info->CommaText=File->ReadString("File",Info->Name,"");
			Add(Info);
		}
		delete	File;
		Application->ProcessMessages();
	}
	delete	SList;
}

/*****	t@CփZ[u	*****/

void __fastcall	TFileList::Save(void)
{
	int		i;

	for(i=0;	i<FList->Count;	i++)
	{
		((TPlayFileInfo*)(FList->Items[i]))->Write();
	}
}

/*****	End	*****/
