/*	Filename:Meter.h							*/
/************************************************/
/*												*/
/*				WXyAipl+	 			*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	[^[W[				*/
/*                             					*/
/*		Copyright 2001,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef MeterH
#define MeterH

#include	"Graphics.hpp"
#include	"ExtCtrls.hpp"
#include	"StdCtrls.hpp"
#include	"DSDEF.h"

//#define	crHandCursor	((TCursor)(16))

/*----------------------------------------------*/
/*				 								*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				TMeterNX					*/
/*----------------------------------------------*/

enum	TMeterType	{mtLevel,mtPeak,mtMask,mtGraphics};

class	TMeter:public TObject
{
private:
	TPanel*		FPanel;
	TLabel*		FLabel[10];
	TColor		FColor[10];
	TMeterType	FType;						//[^^Cv
	int			FDir;						//
	int			FBand;						//oh
	int			FBands;						//Soh
	int			FLevel;						//x
	int			FCount;						//fBCpJE^
	int			FTag;
	TImageList*	FImageList;
	TImage*		FImage;
	bool		FVisibleControl;

protected:
	TLabel* __fastcall	GetLabel(int Index)	{return(FLabel[Index]);}
	TColor __fastcall	GetColor(int Index)	{return(FColor[Index]);}
	void __fastcall	SetColor(int Index,TColor c);
	TColor __fastcall	GetBlue(void)	{return(FColor[0]);}
	void __fastcall	SetBlue(TColor c)	{SetColor(0,c);}
	TColor __fastcall	GetYellow(void)	{return(FColor[6]);}
	void __fastcall	SetYellow(TColor c)	{SetColor(6,c);}
	TColor __fastcall	GetRed(void)	{return(FColor[9]);}
	void __fastcall	SetRed(TColor c)	{SetColor(9,c);}
	int __fastcall  GetPanelBevelWidth(void);
	void __fastcall SetLevel(int level);

public:

	__fastcall	TMeter(TPanel *Panel);
	void __fastcall	MakeBand(int dir,int band,int bands);

	__property	TMeterType	Type={read=FType,write=FType};
	__property	int		Dir={read=FDir,write=FDir};
	__property	int		Band={read=FBand,write=FBand};
	__property	int		Bands={read=FBands,write=FBands};
	__property	int		Level={read=FLevel,write=SetLevel};
	__property	int		Count={read=FCount,write=FCount};
	__property	int		Tag={read=FTag,write=FTag};
	__property	TPanel*	Panel={read=FPanel,write=FPanel};
	__property	TLabel*	Label[int Index]={read=GetLabel};
	__property	TColor	Color[int Index]={read=GetColor,write=SetColor};
	__property	TColor	Blue={read=GetBlue,write=SetBlue};
	__property	TColor	Yellow={read=GetYellow,write=SetYellow};
	__property	TColor	Red={read=GetRed,write=SetRed};
	__property	bool	VisibleControl={read=FVisibleControl,write=FVisibleControl};
	__property	TImageList*	ImageList={read=FImageList,write=FImageList};
	__property	TImage*	Image={read=FImage};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/


#endif

/*****	End	*****/
