/*	Filename:SMFKnife.cpp						*/
/************************************************/
/*												*/
/*					DSMPiCt					*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	SMFiCtW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "SMFKnife.h"
#include "dsmp.h"

#pragma package(smart_init)

/*----------------------------------------------*/
/*				TSMFKnifeNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TSMFKnife::TSMFKnife(HWND Handle)
{
	FHandle=Handle;

	FOption.dwSize=sizeof(SMFKOPTIONINFO);
	FOption.nJv=-1;
	FOption.nBnk=-1;
	FOption.nP=-1;
	FOption.nMac=-1;
	FOption.lParam=(LPARAM)this;

	FEnabled=false;
}

/*****	fXgN^	*****/

__fastcall	TSMFKnife::~TSMFKnife(void)
{

	SetEnabled(false);					//FreeLibrary
}

/*****	Load	*****/

void __fastcall	TSMFKnife::Load(void)
{
	if (FInstance==0)
	then	FInstance=::LoadLibrary("smfk32.dll");
	if (FInstance)
	then {
		FVersion=(TsmfkVersion)::GetProcAddress(FInstance,"GetSmfkVersion");
		if (FVersion==NULL)
		then	FVersion=(TsmfkVersion)::GetProcAddress(FInstance,"_GetSmfkVersion");
		FConvert=(TsmfkConvert)::GetProcAddress(FInstance,"SmfkConvert");
		if (FConvert==NULL)
		then	FConvert=(TsmfkConvert)::GetProcAddress(FInstance,"_SmfkConvert");
		if (FConvert==NULL)
		then {
			MessageDlg("SMFiCtgpł܂",mtError,TMsgDlgButtons()<<mbOK,0);
			Unload();
			FEnabled=false;
		}
	}
	else	FEnabled=false;
}

/*****	Unload	*****/

void __fastcall	TSMFKnife::Unload(void)
{
	if (FInstance)
	then {
		::FreeLibrary(FInstance);
		FInstance=NULL;
		FVersion=NULL;
		FConvert=NULL;
	}
}

/*****	Enabled̐ݒ	*****/

void __fastcall	TSMFKnife::SetEnabled(bool f)
{
	FEnabled=f;

	if (FEnabled)
	then {
		f=Loaded;
		Load();							//gp\CK
		if (f==false)
		then	Unload();
	}
	else {
		Unload();
	}
}

/*****	SMFKo[W̎擾	*****/

int __fastcall	TSMFKnife::GetVersion(void)
{
	if (FVersion)
	then	return(FVersion());

	return(0);
}

/*****	Ro[g	*****/

int __fastcall	TSMFKnife::Convert(AnsiString InFile,AnsiString OutFile)
{
	FError=0;

	FInFile=InFile;
	FOutFile=OutFile;
	FTerminated=false;

	if (FEnabled==false)
	then	return(0);
	if (Loaded==false)
	then {									//SMFKnife[hĂȂ΃[h
		Load();
		if (FEnabled==false)
		then	return(-1);
	}

	if ((!FInFile.IsEmpty())
		AND (!FOutFile.IsEmpty())
		AND (!FConfig.IsEmpty()))
	then {
		FError=FConvert(FHandle,FInFile.c_str(),FOutFile.c_str(),FConfig.c_str(),NULL,&FOption,SMFKCallBack);
		if (FError==-1)
		then	FError=0;
	}

	return(FError);
}

/*****	R[obN	*****/

bool __fastcall	TSMFKnife::CallBack(int nValue)
{
	bool	Abort=false;

	if (FTerminated)
	then	return(false);

	if (FOnCallBack)
	then {
		FOnCallBack(this,nValue,Abort);

		return(!Abort);
	}
	return(true);
}

/******	R[obN֐	******/

int CALLBACK SMFKCallBack(int nValue,LPARAM LParam)
{
	TSMFKnife	*Instance=(TSMFKnife*)LParam;

	if (Instance->ClassNameIs("TSMFKnife"))
	then	return(Instance->CallBack(nValue));

	return(true);
}

/*****	End	*****/
