/*	Filename:SMFKnife.h							*/
/************************************************/
/*												*/
/*					DSMPiCt					*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	SMFiCtW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef SMFKnifeH
#define SMFKnifeH

#include <vcl.h>

/*****	SMFKOPTIONINFO	*****/

typedef struct _SMFKOPTIONINFO
{
	DWORD  dwSize;
	int		nJv;
	int		nBnk;
	int		nP;
	int		nMac;
	LPARAM lParam;
}	SMFKOPTIONINFO,*LPSMFKOPTIONINFO;

typedef int (CALLBACK *SMFKCALLBACK)(int nValue,LPARAM lParam);
typedef	int (WINAPI *TsmfkVersion)(void);
typedef	int (WINAPI *TsmfkConvert)(HWND,LPSTR,LPSTR,LPSTR,LPSTR,LPSMFKOPTIONINFO,SMFKCALLBACK);

typedef void __fastcall (__closure *TSMFKEvent)(System::TObject* Sender,int percent,bool &Abort);

extern	int CALLBACK SMFKCallBack(int nValue,LPARAM LParam);

/*----------------------------------------------*/
/*				TSMFKnifeNX					*/
/*----------------------------------------------*/

class	TSMFKnife:public TObject
{
private:
	HINSTANCE		FInstance;
	bool			FEnabled;
	TsmfkVersion	FVersion;
	TsmfkConvert	FConvert;
	HWND			FHandle;
	int				FError;
	AnsiString		FInFile;
	AnsiString		FOutFile;
	AnsiString		FConfig;
	SMFKOPTIONINFO	FOption;
	TSMFKEvent		FOnCallBack;
	bool			FTerminated;

protected:
	bool __fastcall	GetLoaded(void)	{return(FInstance);}
	void __fastcall	SetEnabled(bool f);
	SMFKOPTIONINFO* __fastcall	GetOption(void)	{return(&FOption);}
	int __fastcall	GetVersion(void);

public:
	__fastcall	TSMFKnife(HWND Handle);
	__fastcall	~TSMFKnife(void);
	void __fastcall	Load(void);
	void __fastcall	Unload(void);
	int	__fastcall	Convert(AnsiString InFile,AnsiString OutFile);
	bool __fastcall	CallBack(int nValue);

	__property	HINSTANCE	Instance={read=FInstance};
	__property	bool		Loaded={read=GetLoaded};
	__property	bool		Enabled={read=FEnabled,write=SetEnabled};
	__property	bool		Terminated={read=FTerminated,write=FTerminated};
	__property	int			Error={read=FError,write=FError};
	__property	int	Version={read=GetVersion};
	__property	AnsiString	InFile={read=FInFile};
	__property	AnsiString	OutFile={read=FOutFile};
	__property	AnsiString	Config={read=FConfig,write=FConfig};
	__property	SMFKOPTIONINFO*	Option={read=GetOption};
	__property	TSMFKEvent	OnCallBack={read=FOnCallBack,write=FOnCallBack};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

#endif

/*****	End	*****/