/*	Filename:RCPCV.cpp							*/
/************************************************/
/*												*/
/*					DSMPiCt					*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 		RCPCVW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "rcpcv.h"
#include "dsmp.h"

#pragma package(smart_init)

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TRCPCV*	RCPCV;

/*----------------------------------------------*/
/*				TRCPCVNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TRCPCV::TRCPCV(void)
{
}

/*****	fXgN^	*****/

__fastcall	TRCPCV::~TRCPCV(void)
{
	SetEnabled(false);
}

/*****	Load	*****/

void __fastcall	TRCPCV::Load(void)
{
	if (FInstance==0)
	then	FInstance=::LoadLibrary("rcpcv.dll");
	if (FInstance)
	then {
		FConvertFile=(TrcpcvConvertFile)::GetProcAddress(FInstance,"rcpcvConvertFile");
		if (FConvertFile==NULL)
		then	FConvertFile=(TrcpcvConvertFile)::GetProcAddress(FInstance,"_rcpcvConvertFile");
		FConvertBuffer=(TrcpcvConvertFileFromBuffer)::GetProcAddress(FInstance,"rcpcvConvertFileFromBuffer");
		if (FConvertBuffer==NULL)
		then	FConvertBuffer=(TrcpcvConvertFileFromBuffer)::GetProcAddress(FInstance,"_rcpcvConvertFileFromBuffer");
		FDeleteObject=(TrcpcvDeleteObject)::GetProcAddress(FInstance,"rcpcvDeleteObject");
		if (FDeleteObject==NULL)
		then	FDeleteObject=(TrcpcvDeleteObject)::GetProcAddress(FInstance,"_rcpcvDeleteObject");
		FGetSMF=(TrcpcvGetSMF)::GetProcAddress(FInstance,"rcpcvGetSMF");
		if (FGetSMF==NULL)
		then	FGetSMF=(TrcpcvGetSMF)::GetProcAddress(FInstance,"_rcpcvGetSMF");
		FSaveSMF=(TrcpcvSaveSMF)::GetProcAddress(FInstance,"rcpcvSaveSMF");
		if (FSaveSMF==NULL)
		then	FSaveSMF=(TrcpcvSaveSMF)::GetProcAddress(FInstance,"_rcpcvSaveSMF");
		FGetSMFLength=(TrcpcvGetSMFLength)::GetProcAddress(FInstance,"rcpcvGetSMFLength");
		if (FGetSMFLength==NULL)
		then	FGetSMFLength=(TrcpcvGetSMFLength)::GetProcAddress(FInstance,"_rcpcvGetSMFLength");
		FGetFileType=(TrcpcvGetOriginalFileType)::GetProcAddress(FInstance,"rcpcvGetOriginalFileType");
		if (FGetFileType==NULL)
		then	FGetFileType=(TrcpcvGetOriginalFileType)::GetProcAddress(FInstance,"_rcpcvGetOriginalFileType");
		FGetVersionMajor=(TrcpcvGetVersionMajor)::GetProcAddress(FInstance,"rcpcvGetVersionMajor");
		if (FGetVersionMajor==NULL)
		then	FGetVersionMajor=(TrcpcvGetVersionMajor)::GetProcAddress(FInstance,"_rcpcvGetVersionMajor");
		FGetVersionMinor=(TrcpcvGetVersionMinor)::GetProcAddress(FInstance,"rcpcvGetVersionMinor");
		if (FGetVersionMinor==NULL)
		then	FGetVersionMinor=(TrcpcvGetVersionMinor)::GetProcAddress(FInstance,"_rcpcvGetVersionMinor");
		FGetCopyright=(TrcpcvGetCopyright)::GetProcAddress(FInstance,"rcpcvGetCopyright");
		if (FGetCopyright==NULL)
		then	FGetCopyright=(TrcpcvGetCopyright)::GetProcAddress(FInstance,"_rcpcvGetCopyright");

		if ((FConvertFile==NULL) OR (FSaveSMF==NULL))
		then {
			MessageDlg("RCPCVgpł܂",mtError,TMsgDlgButtons()<<mbOK,0);
			Unload();
			FEnabled=false;
		}
	}
	else	FEnabled=false;
}

/*****	Unload	*****/

void __fastcall	TRCPCV::Unload(void)
{
	if (FInstance)
	then {
		::FreeLibrary(FInstance);
		FInstance=NULL;
		FSaveSMF=NULL;
		FConvertFile=NULL;
	}
}

/*****	Enabled̐ݒ	*****/

void __fastcall	TRCPCV::SetEnabled(bool f)
{
	FError=0;
	FEnabled=f;

	if (FEnabled)
	then {
		f=Loaded;
		Load();							//gp\CK
		if (f==false)
		then	Unload();
	}
	else {
		Unload();
	}
}

/*****	Ro[g	*****/

void __fastcall	TRCPCV::Convert(AnsiString InFile,AnsiString OutFile)
{
	FError=0;
	FTerminated=false;

	if (FEnabled==false)
	then	return;

	if (Loaded==false)
	then {									//RCPCV[hĂȂ΃[h
		Load();
		if (FEnabled==false)
		then	return;
	}

	if ((!InFile.IsEmpty()) AND (!OutFile.IsEmpty()))
	then {
		FHandle=FConvertFile(InFile.c_str(),RCPCV_CALLBACK_FUNCTION,(DWORD)RCPCVCallBack,0,(DWORD)this);
		if (FHandle)
		then {
			FError=FSaveSMF(FHandle,OutFile.c_str());

			FDeleteObject(FHandle);
		}
	}
}

/*****	R[obN	*****/

int __fastcall	TRCPCV::CallBack(RCPCVDATA *data)
{
	bool	Abort=false;

	if (FTerminated)
	then	return(false);

	if (FOnCallBack)
	then{
		FOnCallBack(this,(int)data->percent,Abort);

		return(!Abort);
	}

	return(true);
}

/*****	R[obN	*****/

int CALLBACK	RCPCVCallBack(RCPCVDATA *data)
{
	TRCPCV	*Instance=(TRCPCV*)(data->dwUser);

	if (Instance->ClassNameIs("TRCPCV"))
	then	return(Instance->CallBack(data));

	return(true);
}

/*****	End	*****/