/*	Filename:RCPCV.h							*/
/************************************************/
/*												*/
/*					DSMPiCt					*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 		RCPCVW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef rcpcvH
#define rcpcvH

#include <vcl.h>


#define RCPCV_FORMATTYPE_RCM20		1
#define RCPCV_FORMATTYPE_RCM25F		2
#define RCPCV_FORMATTYPE_RCM25G		3
#define RCPCV_FORMATTYPE_RCFW95		4

#define RCPCV_CALLBACK_NULL		0
#define RCPCV_CALLBACK_WINDOW	1
#define RCPCV_CALLBACK_FUNCTION	2

typedef	DWORD	HRCPCV;

typedef struct
{
	DWORD track;
	DWORD tracks;
	DWORD percent;
	DWORD dwUser;
}	RCPCVDATA;

typedef	RCPCVDATA*	LRCPCVDATA;

typedef int	(CALLBACK *RCPCVCALLBACK)(LRCPCVDATA);
typedef	HRCPCV	(CALLBACK *TrcpcvConvertFile)(LPCSTR filename, UINT callbackType, DWORD callback, UINT wMessage, DWORD user);
typedef	HRCPCV	(CALLBACK *TrcpcvConvertFileFromBuffer)(LPCSTR buffer, UINT bufferlength, UINT format, UINT callbackType, DWORD callback, UINT wMessage, DWORD user);
typedef	void	(CALLBACK *TrcpcvDeleteObject)(HRCPCV);
typedef	LPCSTR	(CALLBACK *TrcpcvGetSMF)(HRCPCV);
typedef	int		(CALLBACK *TrcpcvSaveSMF)(HRCPCV, LPCSTR);
typedef	int		(CALLBACK *TrcpcvGetSMFLength)(HRCPCV);
typedef	int		(CALLBACK *TrcpcvGetOriginalFileType)(HRCPCV);
typedef	int		(CALLBACK *TrcpcvGetVersionMajor)(void);
typedef	int		(CALLBACK *TrcpcvGetVersionMinor)(void);
typedef	LPCSTR	(CALLBACK *TrcpcvGetCopyright)(void);

typedef void __fastcall (__closure *TRCPCVEvent)(System::TObject* Sender,int percent,bool &Abort);

extern	int CALLBACK	RCPCVCallBack(RCPCVDATA *data);

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				TRCPCVNX					*/
/*----------------------------------------------*/

class	TRCPCV:public TObject
{
private:
	HINSTANCE	FInstance;
	bool		FEnabled;
	bool		FTerminated;
	HRCPCV		FHandle;
	int			FError;

	TRCPCVEvent	FOnCallBack;

	TrcpcvConvertFile			FConvertFile;
	TrcpcvConvertFileFromBuffer	FConvertBuffer;
	TrcpcvDeleteObject			FDeleteObject;
	TrcpcvGetSMF				FGetSMF;
	TrcpcvSaveSMF				FSaveSMF;
	TrcpcvGetSMFLength			FGetSMFLength;
	TrcpcvGetOriginalFileType	FGetFileType;
	TrcpcvGetVersionMajor		FGetVersionMajor;
	TrcpcvGetVersionMinor		FGetVersionMinor;
	TrcpcvGetCopyright			FGetCopyright;

protected:
	bool __fastcall	GetLoaded(void)	{return(FInstance);}
	void __fastcall	SetEnabled(bool f);

public:
	__fastcall	TRCPCV(void);
	__fastcall	~TRCPCV(void);
	void __fastcall	Load(void);
	void __fastcall	Unload(void);
	void __fastcall	Convert(AnsiString InFile,AnsiString OutFile);
	int __fastcall	CallBack(RCPCVDATA *data);

	__property	HINSTANCE	Instance={read=FInstance};
	__property	bool	Loaded={read=GetLoaded};
	__property	bool	Enabled={read=FEnabled,write=SetEnabled};
	__property	bool   	Terminated={read=FTerminated,write=FTerminated};
	__property	int		Error={read=FError,write=FError};
	__property	TRCPCVEvent	OnCallBack={read=FOnCallBack,write=FOnCallBack};
};

#endif
