/*	Filename:main.cpp							*/
/************************************************/
/*												*/
/*					LyrPanel+					*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "main.h"

#pragma package(smart_init)

/*****	TCharset	*****/

typedef	struct
{
	Char	*String;
	int		Charset;
}	TCharset;

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TDSMPInterface	*DSMPIntf;
int				Version=6310;
HANDLE			hMutex;
TLyrPanel		*LyrPanel;

TCharset	Charset[]=
{
	{"ANSI",ANSI_CHARSET},		   			//ANSI
	{"DEFAULT",DEFAULT_CHARSET},   			//Default
	{"SYMBOL",SYMBOL_CHARSET},				//Symbol
	{"MAC",MAC_CHARSET},					//Macintosh
	{"SHIFTJIS",SHIFTJIS_CHARSET},			//Japanese
	{"HANGEUL",HANGEUL_CHARSET},			//Hangeul (Wansung)
	{"JOHAB",JOHAB_CHARSET},				//Hangeul (Johab)
	{"GB2312",GB2312_CHARSET},				//Chineseiȑ̎j
	{"CHINESEBIG5",CHINESEBIG5_CHARSET},	//Chinesei`Ij
	{"GREEK",GREEK_CHARSET},				//Greek
	{"TURKISH",TURKISH_CHARSET},			//Turkish
	{"VIETNAMESE",VIETNAMESE_CHARSET},		//Vietnamese
	{"HEBREW",HEBREW_CHARSET},				//Hebrew
	{"ARABIC",ARABIC_CHARSET},				//Arabic
	{"BALTIC",BALTIC_CHARSET},				//Baltic
	{"RUSSIAN",RUSSIAN_CHARSET},			//Russian
	{"THAI",THAI_CHARSET},					//Thai
	{"EASTEUROPE",EASTEUROPE_CHARSET},		//East Europe
	{"OEM",OEM_CHARSET},					//OEM
	{"",-1}									//End
};

/*----------------------------------------------*/
/*				GNX|[g					*/
/*----------------------------------------------*/

/*****	vOC̎s	*****/

void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if ((DSMPIntf->CheckVersion(DSMP_DLLVERSION)==false)
		OR (DSMPIntf->GetVersion()<DSMP_VERSION))
	then {
		MessageDlg("LyrPanel+\n\ño[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);
		DSMPIntf->Abort();
		return;
	}
	hMutex=::CreateMutex(NULL,FALSE,"LyrPanel");
	if ((hMutex==0) OR (::GetLastError()==ERROR_ALREADY_EXISTS))
	then {
		DSMPIntf->Abort();		  					//2dNȂI
		return;
	}

	LyrPanel=new TLyrPanel(DSMPIntf->GetPlayerForm());
}

/*****	vOC̏I	*****/

void	pinAbort(void)
{
	if (LyrPanel)
	then {
		delete	LyrPanel;
		LyrPanel=NULL;
	}

	if (hMutex)
	then {
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		hMutex=0;
	}
}

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	NH[e[V␳	*****/

AnsiString __fastcall	CorrectQuoted(AnsiString S)
{
	char	*p,*q;

	if (S.IsEmpty())
	then	return("");

	p=AnsiStrScan(S.c_str(),'\"');
	if (p==NULL)
	then	return(S);
/*
	if ((S[1] != '\"') AND (S[1] != ','))
	then {
		S="\""+S;
		fh=true;
	}
*/
	int		n=0;
	bool	f=false;

	p=S.c_str();
	while(p)
	{
		p=AnsiStrScan(p,'\"');
		if (p)
		then {
			p++;
			n++;
			if (n & 1)
			then {
				q=p;
				while(*q)
				{
					if ((*q != 0x20) AND (*q != '\t'))
					then	break;
					q++;
				}
				if (*q==',')
				then {
					q++;
					while(*q)
					{
						if ((*q != 0x20) AND (*q != '\t'))
						then	break;
						q++;
					}
					if ((*q=='\"') OR (*q==','))
					then	f=true;
				}
			}
		}
	}
	if (f)
	then {
		S="\""+S;
		n++;
	}
	if (n & 1)
	then	S+="\"";

	return(S);
}

/*****	FONTWJ	*****/
/*
	Font=tHg,Size,ChrSet,Style
*/
void __fastcall	ExtractFont(AnsiString S,AnsiString &Name,int &Height,TFontStyles &Style,TFontCharset &Chrset)
{
	int		i,n;

	AnsiString	s=S.LowerCase();
	n=s.AnsiPos("font=");
	if (n)
	then S=S.SubString(n+5,S.Length()-(n+5)+1);

	TStringList	*SList=new TStringList();
	SList->CommaText=S;
	while(SList->Count<2)
	{
		SList->Add("");
	}
	s=SList->Strings[0];
	if (!s.IsEmpty())
	then {
		Name=s;
		Chrset=DEFAULT_CHARSET;
	}
	n=SList->Strings[1].ToIntDef(0);
	if (n<0)
	then	Height=n;
	else if (n>0)
	then	Height=-n*96/72;						//|CgTCYsNZTCYɂ

	SList->Delete(0);
	SList->Delete(0);

	if (SList->Count)
	then {
		for(i=0;	i<SList->Count;	i++)
		{
			SList->Strings[i]=SList->Strings[i].UpperCase();
		}
		for(i=0;	Charset[i].Charset>=0;	i++)
		{
			n=SList->IndexOf(Charset[i].String);
			if (n>=0)
			then {
				Chrset=Charset[i].Charset;
				SList->Delete(n);
				break;
			}
		}
		if ((SList->IndexOf("NORMAL")>=0)
			OR (SList->IndexOf("BOLD")>=0)
			OR (SList->IndexOf("ITALIC")>=0)
			OR (SList->IndexOf("UNDERLINE")>=0)
			OR (SList->IndexOf("STRIKEOUT")>=0))
		then	Style=Style.Clear();

		if (SList->IndexOf("NORMAL")>=0)
		then	Style=Style.Clear();
		if (SList->IndexOf("BOLD")>=0)
		then	Style=Style<<fsBold;
		if (SList->IndexOf("ITALIC")>=0)
		then	Style=Style<<fsItalic;
		if (SList->IndexOf("UNDERLINE")>=0)
		then	Style=Style<<fsUnderline;
		if (SList->IndexOf("STRIKEOUT")>=0)
		then	Style=Style<<fsStrikeOut;
	}
	delete	SList;
}

/*****  tHg̎擾  *****/

void __fastcall   SetFont(TFont *Font,AnsiString S)
{
	AnsiString		Name=Font->Name;
	int				Height=Font->Height;
	TFontCharset	Chrset=Font->Charset;
	TFontStyles 	Style=Font->Style;

	ExtractFont(S,Name,Height,Style,Chrset);

	Font->Name=Name;
	Font->Height=Height;
	Font->Charset=Chrset;
	Font->Style=Style;
}

/*****	" - "ŘA	*****/

AnsiString __fastcall	ConnectString(AnsiString S1,AnsiString S2)
{
	AnsiString	S;

	if ((!S1.IsEmpty()) AND (!S2.IsEmpty()))
	then {
		S=S1;
		S+=" - ";
		S+=S2;
	}
	else {
		S=S1;
		S+=S2;
	}

	return(S);
}

/*----------------------------------------------*/
/*				TLyrPanelNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TLyrPanel::TLyrPanel(TComponent *Owner)
:TComponent(Owner)
{
	AnsiString	Section;
	AnsiString	S;
	int			i,n;
	bool	fTimer=false;

	FDSMP=new TDSMP(Owner);
	FDSMP->Bind();

	FDSMPForm=(TForm*)DSMPIntf->GetPlayerForm();
	PanelCaption=(TPanel*)DSMPIntf->GetControl(DSMP_ID_CAPTION);
	PanelDisplay=(TPanel*)DSMPIntf->GetControl(DSMP_ID_DISPLAYPANEL);
	PanelTitle=(TPanel*)DSMPIntf->GetControl(DSMP_ID_TITLE);
	PanelArtist=(TPanel*)DSMPIntf->GetControl(DSMP_ID_ARTIST);
	PanelDevice=(TPanel*)DSMPIntf->GetControl(DSMP_ID_DEVICE);

	FDisplayPanel=true;
	FColorKey=true;

	TStringList	*SList=new TStringList();
	TMemIniFile	*File=new TMemIniFile(DSMP->Design);

	FDesign=File->ReadString("DSMPD","DesignName","");
	S=File->ReadString("DSMPD","Designer","");
	if (!S.IsEmpty())
	then {
		FDesign+=" / ";
		FDesign+=S;
	}

	if (File->SectionExists("LyrPanel"))
	then {
		FDisplayPanel=false;
		Section="LyrPanel";
		LyrPanel=new TPanel(FDSMPForm);
		LyrPanel->Name=Section;
		LyrPanel->Parent=FDSMPForm;
		SetControl((TCControl*)LyrPanel,File,Section);

		if (LyrPanel->Visible==false)
		then {
			delete	LyrPanel;
			LyrPanel=NULL;
			Section="";
		}
		else {
			LyrPanel->BevelInner=bvNone;
			LyrPanel->BevelOuter=bvNone;
			LyrPanel->BorderStyle=bsNone;
			LyrPanel->ShowHint=true;
			LyrPanel->Caption="";
		}
	}
	else if (FDisplayPanel)
	then {
		Section="DisplayPanel";
		LyrPanel=PanelDisplay;
		if ((LyrPanel->Visible==false)
			OR (File->ReadBool(Section,"Checked",false))
			OR (File->ReadBool(Section,"LyrPanel",true)==false))
		then {
			Section="";
			LyrPanel=NULL;
		}
	}
	else {
		Section="";
	}

	if (!Section.IsEmpty())
	then {
		LyrPanel->Alignment=taCenter;

		LyrPanel->Hint=FDesign;
		if ((LyrPanel->Font->Name=="lr o")
			OR (LyrPanel->Font->Name=="lr "))
		then	FontChange=true;
		else	FontChange=false;

		LyrLabel=new TLabel(LyrPanel->Owner);
		LyrLabel->Name="LyrLabel";
		LyrLabel->Parent=LyrPanel;
		DSMPIntf->SetControlID(LyrLabel);

		InitLabel(LyrLabel);
		LyrLabel->Transparent=File->ReadBool(Section,"Transparent",false);
		LyrLabel->ParentFont=false;
		LyrLabel->Font->Assign(LyrPanel->Font);
		LyrLabel->Caption=FDesign;

		TPanel	*Panel=(TPanel*)DSMPIntf->GetControl(DSMP_ID_LYRICS);
		FPanelColor=Panel->Font->Color;
		FColor=LyrPanel->Font->Color;

		FScrollPanel[SCROLLPANELMAX]=LyrPanel;
		FScrollLabel[SCROLLPANELMAX]=LyrLabel;
		FScrollType[SCROLLPANELMAX]=File->ReadInteger(Section,"Type",0);
		FScrollChecked[SCROLLPANELMAX]=File->ReadInteger(Section,"Checked",0);

		S=File->ReadString(Section,"Option","");
		SList->CommaText=S.LowerCase();

		if (SList->IndexOf("coloroff")>=0)				//ʌ݊̈
		then	FColorKey=false;
		if (SList->IndexOf("coloron")>=0)
		then	FColorKey=true;

		S=SList->Values["color"];
		if (S=="off")
		then	FColorKey=false;
		else if (S=="on")
		then	FColorKey=true;

		S=SList->Values["scroll"];
		if (!S.IsEmpty())
		then	FScrollTime[SCROLLPANELMAX]=S.ToIntDef(100);
		else	FScrollTime[SCROLLPANELMAX]=100;

		FScrollStep[SCROLLPANELMAX]=File->ReadInteger(Section,"Level",1);
		n=File->ReadInteger(Section,"Alignment",0);
		if ((FScrollStep[SCROLLPANELMAX]) AND (FScrollTime[SCROLLPANELMAX]))
		then {
			FScrollStep[SCROLLPANELMAX]=FScrollStep[SCROLLPANELMAX]*(n*2-1);
			fTimer=true;
		}
		else {
			FScrollTime[SCROLLPANELMAX]=0; 					//荞݂Ȃ
		}

		LyrLabel->Visible=true;
	}

	for(i=0;	i<SCROLLPANELMAX;	i++)
	{
		Section="ScrollPanel";
		Section+=i;

		if (File->SectionExists(Section))
		then {
			FScrollLabel[i]=MakePanel(Section,File);
			FScrollPanel[i]=(TPanel*)FScrollLabel[i]->Parent;
			FScrollType[i]=File->ReadInteger(Section,"Type",0);
			FScrollChecked[i]=File->ReadInteger(Section,"Checked",0);

			S=File->ReadString(Section,"Option","");
			SList->CommaText=S.LowerCase();

			S=SList->Values["scroll"];
			if (!S.IsEmpty())
			then	FScrollTime[i]=S.ToIntDef(100);
			else	FScrollTime[i]=100;

			FScrollStep[i]=File->ReadInteger(Section,"Level",1);
			n=File->ReadInteger(Section,"Alignment",0);
			if ((FScrollStep[i]) AND (FScrollTime[i]))
			then {
				FScrollStep[i]=FScrollStep[i]*(n*2-1);
				fTimer=true;
			}
			else {
				FScrollLabel[i]->Alignment=(TAlignment)n;
				FScrollTime[i]=0;
			}

			FScrollLabel[i]->Visible=true;
		}
		else {
			FScrollPanel[i]=NULL;
			FScrollLabel[i]=NULL;
		}
	}

	delete	File;
	delete	SList;

	FDSMP->OnUser=DSMPOnUser;
	FDSMP->OnOpenTrack=DSMPOnOpenTrack;
	FDSMP->OnCloseTrack=DSMPOnCloseTrack;
	FDSMP->OnLoadLyrics=DSMPOnLoadLyrics;
	FDSMP->OnLyrics=DSMPOnLyrics;
	FDSMP->OnDisplayTitle=DSMPOnDisplayTitle;
	FDSMP->OnDisplayCaption=DSMPOnDisplayCaption;
	FDSMP->OnIntTimer=DSMPOnIntTimer;
	if (LyrLabel)
	then	FDSMP->Events=TDSMPEventSets()<<evLyrics;
	if (fTimer)
	then	FDSMP->Events=FDSMP->Events<<evTimer;

/*
zCgAEgh~̂߁AgɃCxg𔭐āA
xDSMPɐ߂Aŕ\XV
*/
	DSMP->NotifyEvent(DSMP->Handle,DSMP_NOTIFY_USER | DSMP_NOTIFY_LYRICS,0);	//Modified Ver.3.332
}

/*****  Rg[̐ݒ    *****/

void __fastcall TLyrPanel::SetControl(TCControl *Control,TMemIniFile *File,AnsiString Section)
{
	Control->Left=File->ReadInteger(Section,"Left",-1);
	Control->Top=File->ReadInteger(Section,"Top",-1);
	Control->Width=File->ReadInteger(Section,"Width",0);
	Control->Height=File->ReadInteger(Section,"Height",0);
	Control->Visible=File->ReadBool(Section,"Visible",false);
	Control->Enabled=true;

	AnsiString	S=File->ReadString(Section,"Font","");
	Control->Font->Style=Control->Font->Style.Clear();
	::SetFont(Control->Font,CorrectQuoted(S));

	Control->Font->Color=(TColor)File->ReadInteger(Section,"Color",(int)clAqua);
	Control->Color=(TColor)File->ReadInteger(Section,"BackColor",(int)clBlack);

	Control->OnClick=((TCControl*)Control->Parent)->OnClick;
	Control->OnDblClick=((TCControl*)Control->Parent)->OnDblClick;
	Control->OnMouseDown=((TCControl*)Control->Parent)->OnMouseDown;
	Control->OnMouseMove=((TCControl*)Control->Parent)->OnMouseMove;
	Control->OnMouseUp=((TCControl*)Control->Parent)->OnMouseUp;
}

/*****  x̏    *****/

void __fastcall	TLyrPanel::InitLabel(TLabel *Label)
{
	TPanel	*Parent=(TPanel*)Label->Parent;

	Label->AutoSize=false;
	Label->Align=alClient;
	Label->WordWrap=false;
	Label->ShowAccelChar=false;
	Label->Alignment=taCenter;
	Label->Layout=tlCenter;
	Label->Transparent=false;
	Label->Font->Assign(Parent->Font);
	Label->Color=Parent->Color;
	Label->Caption="";
	Label->ParentShowHint=true;
	Label->ParentColor=true;
	Label->ParentFont=true;
	Label->Enabled=true;
	Label->OnClick=Parent->OnClick;
	Label->OnDblClick=Parent->OnDblClick;
	Label->OnMouseDown=Parent->OnMouseDown;
	Label->OnMouseMove=Parent->OnMouseMove;
	Label->OnMouseUp=Parent->OnMouseUp;
}

/*****	pl̍쐬	*****/

TLabel* __fastcall	TLyrPanel::MakePanel(AnsiString Name,TMemIniFile *File)
{
	TPanel	*Panel=new TPanel(FDSMPForm);
	Panel->Name=Name;
	Panel->Parent=FDSMPForm;
	if (File)
	then	SetControl((TCControl*)Panel,File,Panel->Name);
	Panel->Alignment=taLeftJustify;
	Panel->BevelInner=bvNone;
	Panel->BevelOuter=bvNone;
	Panel->BorderStyle=bsNone;
	Panel->ShowHint=true;
	Panel->Caption="";
	Panel->Hint=Name;

	TLabel	*Label=new TLabel(FDSMPForm);
	Label->Name=StringReplace(Name,"Panel","Label",TReplaceFlags()<<rfIgnoreCase);
	Label->Parent=Panel;
	InitLabel(Label);
	Label->Align=alNone;
	Label->Alignment=taLeftJustify;

	return(Label);
}

/*****	fXgN^	*****/

__fastcall	TLyrPanel::~TLyrPanel(void)
{
	int		i;

	delete	FDSMP;

	if (LyrLabel)
	then {
		LyrPanel->Hint="";
		delete	LyrLabel;
		if (FDisplayPanel==false)
		then	delete	LyrPanel;
	}

	for(i=0;	i<SCROLLPANELMAX;	i++)
	{
		if (FScrollPanel[i])
		then {
			delete	FScrollLabel[i];
			delete	FScrollPanel[i];
		}
	}
}

/*****	DSMP_NOTIFY_USER	*****/

void __fastcall	TLyrPanel::DSMPOnUser(TObject* Sender,DWORD Event,int Param)
{
	if (Event==DSMP_NOTIFY_LYRICS)
	then {
		DSMPOnLoadLyrics(this);
		DSMPOnLyrics(this,-1);

		SetScrollCaption();
	}
}

/*****	gbÑI[v	*****/

void __fastcall TLyrPanel::DSMPOnOpenTrack(TObject *Sender, int Track)
{
	if (LyrLabel==NULL)
	then	return;

	DSMPOnLoadLyrics(Sender);

	if (FScrollLyrEnabled)
	then {
		TTrackInfo	Info=DSMP->TrackInfo[DSMP->Track];
		AnsiString	S;
		if (!Info.Artist.IsEmpty())
		then	S=Info.Artist;
		if (!Info.Title.IsEmpty())
		then {
			if (!S.IsEmpty())
			then	S+=" - ";
			S+=Info.Title;
		}
		S=S.Trim();
		if (S.IsEmpty())
		then {
			S=PanelCaption->Caption;
		}
		if (S.IsEmpty())
		then	FScrollLyrEnabled=false;
		else {
			LyrLabel->Alignment=taLeftJustify;
			LyrLabel->Align=alNone;
			LyrLabel->Width=LyrPanel->Width;
			LyrLabel->WordWrap=false;
			LyrLabel->AutoSize=true;
			LyrLabel->Left=LyrPanel->Width;
			LyrLabel->Caption=S;
			LyrLabel->AutoSize=false;
			LyrLabel->Height=LyrPanel->Height;

			FScrollCounter[SCROLLPANELMAX]=FScrollTime[SCROLLPANELMAX];
		}
	}

//	if (TitlePanel)
//	then	TitleLabel->Left=TitlePanel->Width;
/*
	if ((ArtistPanel)
		AND (TitlePanel))
	then	ArtistLabel->Left=TitleLabel->Left;
*/
	SetScrollCaption();
}

/*****	gbÑN[Y	*****/

void __fastcall TLyrPanel::DSMPOnCloseTrack(TObject *Sender, int Track)
{
	if (LyrLabel==NULL)
	then	return;

	LyrLabel->Color=LyrPanel->Color;

	if (FScrollLyrEnabled)
	then {
		FScrollLyrEnabled=false;
		LyrLabel->Caption="";
		SetLabel();
	}
}

/*****	̎t@C[hꂽ	*****/

void __fastcall	TLyrPanel::DSMPOnLoadLyrics(TObject* Sender)
{
	if (LyrLabel==NULL)
	then	return;

	FScrollLyrEnabled=false;
	if ((DSMP->LyricsList->FileName.IsEmpty())
		AND (FScrollTime[SCROLLPANELMAX]))
	then	FScrollLyrEnabled=true;
	else {
		LyrLabel->Alignment=taCenter;
		LyrLabel->AutoSize=false;
		LyrLabel->Left=0;
	}

	LyrPanel->Hint=DSMP->LyricsList->Comment;
	if (LyrPanel->Hint.IsEmpty())
	then {
		AnsiString	S;

		if (DSMP->Track)
		then {
			TTrackInfo	Info=DSMP->TrackInfo[DSMP->Track];

			S=DSMP->LyricsList->Presenter;
			if (!S.IsEmpty())
			then S+=" / ";
			S+=Info.Title;
			S+=" / ";
			S+=Info.Artist;
		}
		else	S=FDesign;
		LyrPanel->Hint=S;
	}
	LyrLabel->Align=alNone;

	SetLabel();
}

/*****	x̐ݒ	*****/

void __fastcall	TLyrPanel::SetLabel(void)
{
	if (DSMP->LyricsList->Width==DEFWIDTH)
	then	FZoom=(double)LyrPanel->Height/DEFHEIGHT;
	else	FZoom=(double)LyrPanel->Width/DSMP->LyricsList->Width;

	LyrLabel->Width=DSMP->LyricsList->Width*FZoom;
	LyrLabel->Height=DSMP->LyricsList->Height*FZoom;
	LyrLabel->Left=(LyrPanel->Width-LyrLabel->Width)/2;
	LyrLabel->Top=(LyrPanel->Height-LyrLabel->Height)/2;
	LyrLabel->Color=LyrPanel->Color;

	FontHeight=0;
}

/*****	̎\Cxg	*****/

void __fastcall TLyrPanel::DSMPOnLyrics(TObject* Sender,int Param)
{
	if (LyrLabel==NULL)
	then	return;

//	FScrollTitleEnabled=false;

	TLyrics	*Lyr=DSMP->Text;

//	if (Lyr->Font->Height==0)
//	then	return;

	if (FScrollLyrEnabled)
	then {
		if (!Lyr->Text.IsEmpty())
		then {
			SetLabel();
			LyrLabel->Caption=Lyr->Text;
			FScrollLyrEnabled=false;
		}
	}
	else {
		LyrLabel->Caption=Lyr->Text;
	}

	if (LyrLabel->Alignment != Lyr->Alignment)
	then	LyrLabel->Alignment=Lyr->Alignment;
	if (LyrLabel->WordWrap != Lyr->WordWrap)
	then	LyrLabel->WordWrap=Lyr->WordWrap;
	if (LyrLabel->ShowAccelChar != Lyr->ShowAccelChar)
	then	LyrLabel->ShowAccelChar=Lyr->ShowAccelChar;
	if (LyrLabel->Color != Lyr->BackColor)
	then	LyrLabel->Color=Lyr->BackColor;

	if ((FontName != Lyr->Font->Name)
		OR (LyrLabel->Font->Charset != Lyr->Font->Charset)
		OR (FontHeight != Lyr->Font->Height)
		OR (LyrLabel->Font->Style != Lyr->Font->Style)
		OR (FColor != Lyr->Font->Color))
	then {
		FontName=Lyr->Font->Name;
		FontHeight=Lyr->Font->Height;
		FColor=Lyr->Font->Color;

		LyrLabel->Font->Assign(Lyr->Font);
		if ((FColorKey==false) OR (FColor==FPanelColor))
		then	LyrLabel->Font->Color=LyrPanel->Font->Color;

		if (FontChange)
		then {
			if (FontName=="lr oSVbN")
			then	LyrLabel->Font->Name="lr o";
			else if (FontName=="lr SVbN")
			then	LyrLabel->Font->Name="lr ";
		}
		LyrLabel->Font->Height=FontHeight*FZoom;
	}
	LyrLabel->Update();		  			//R}h~ׂ̈̋Cx߁H
}

/*****	^Cg\Cxg	*****/

void __fastcall TLyrPanel::DSMPOnDisplayTitle(TObject* Sender,int Param)
{
	SetScrollCaption();
}

/*****	LvV\Cxg	*****/

void __fastcall TLyrPanel::DSMPOnDisplayCaption(TObject* Sender)
{
	SetScrollCaption();
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TLyrPanel::GetFileName(bool f)
{
	AnsiString	S;

	if ((FDSMP->Tracks) AND (FDSMP->Track))
	then {
		TTrackInfo	Info=FDSMP->TrackInfo[FDSMP->Track];
		S=Info.FileName;
		if (f)
		then	S=ExtractFileName(S);
	}
	return(S);
}

/*****	XN[plLvV̐ݒ	*****/

void __fastcall TLyrPanel::SetScrollCaption(void)
{
	TPanel	*Panel;
	TLabel	*Label;
	int			i;
	AnsiString	S,s;

	for(i=0;	i<SCROLLPANELMAX;	i++)
	{
		Panel=FScrollPanel[i];
		Label=FScrollLabel[i];
		if (Panel)
		then {
			S="";
			switch(FScrollType[i])
			{
				case 0:
					S=PanelTitle->Caption;
					if (FScrollChecked[i])
					then {
						S=ConnectString(PanelArtist->Caption,S);
						if (S.IsEmpty())
						then	S=GetFileName(true);
						if (S.IsEmpty())
						then	S=PanelCaption->Caption;
					}
					break;
				case 1:
					S=PanelArtist->Caption;
					if (FScrollChecked[i])
					then	S=ConnectString(S,PanelTitle->Caption);
					break;
				case 2:
					S=GetFileName(FScrollChecked[i]);
					break;
				case 3:
					S=PanelCaption->Caption;
					if (FScrollChecked[i])
					then {
						S=ConnectString(S,PanelArtist->Caption);
						S=ConnectString(S,PanelTitle->Caption);
					}
					break;
				case 4:
					if (FScrollChecked[i])
					then {
						s=ConnectString(PanelArtist->Caption,PanelTitle->Caption);
						if (s.IsEmpty())
						then	s=GetFileName(true);
					}
					S=PanelDevice->Hint;
					if ((S.AnsiPos(":")==0) OR (FDSMP->Tracks==0))
					then	S="";
					S=ConnectString(s,S);
					break;
				case 7:
					S=ConnectString(PanelArtist->Caption,PanelTitle->Caption);
					if ((S.IsEmpty()) AND (FScrollChecked[i]==false))
					then	S=GetFileName(true);
					S=ConnectString(PanelCaption->Caption,S);
					if (FScrollChecked[i])
					then	S=ConnectString(S,GetFileName());
					s=PanelDevice->Hint;
					if ((s.AnsiPos(":")==0) OR (FDSMP->Tracks==0))
					then	s="";
					S=ConnectString(S,s);
					break;
			}
			if (FDSMP->Tracks==0)
			then	Label->Left=0;
			Label->AutoSize=true;
			Label->Caption=S;
			Panel->Hint=S;
			Label->AutoSize=false;
			Label->Height=Panel->Height;
		}
	}

}

/*****	XN[	*****/

void __fastcall	TLyrPanel::Scroll(int n,int tm)
{
	TLabel *Label=FScrollLabel[n];

	if (Label==NULL)
	then	return;

	FScrollCounter[n]-=tm;
	if (FScrollCounter[n]<=0)
	then {
		FScrollCounter[n]+=FScrollTime[n];
		if (FScrollCounter[n]<=0)
		then	FScrollCounter[n]=FScrollTime[n];

		Label->Left=Label->Left+FScrollStep[n];
		if (FScrollStep[n]<0)
		then {
			if (Label->Left<-(Label->Width))
			then	Label->Left=FScrollPanel[n]->Width;
		}
		else {
			if (Label->Left>=FScrollPanel[n]->Width)
			then	Label->Left=-Label->Width;
		}
	}
}

/*****	^C}[荞	*****/

void __fastcall TLyrPanel::DSMPOnIntTimer(TObject* Sender,int Param)
{
	static	int	PrevTime;
	int		tm=Param-PrevTime;
	PrevTime=Param;
	int		i;

	if (FScrollLyrEnabled)
	then {
		Scroll(SCROLLPANELMAX,tm);
	}

	for(i=0;	i<SCROLLPANELMAX;	i++)
	{
		if (FScrollPanel[i])
		then	Scroll(i,tm);
	}
}

/*****	ĐԂς	*****/
/*
void __fastcall TLyrPanel::DSMPOnPlayStatus(TObject* Sender,int Param)
{

}
*/
/*****	End	*****/
