/*	Filename:main.h								*/
/************************************************/
/*												*/
/*					LyrPanel+					*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include "DSMP.h"

#define	DEFWIDTH		246
#define	DEFHEIGHT		38
#define	SCROLLPANELMAX	10

/*----------------------------------------------*/
/*				TCControlNX					*/
/*----------------------------------------------*/

class	TCControl:public TControl
{
public:
	__property	Font;
	__property	Caption;
	__property	Hint;
	__property	Color;
	__property	OnClick;
	__property	OnDblClick;
	__property	OnMouseDown;
	__property	OnMouseMove;
	__property	OnMouseUp;
};

/*----------------------------------------------*/
/*				TLyrPanelNX					*/
/*----------------------------------------------*/

class	TLyrPanel:public TComponent
{
private:
	TDSMP		*FDSMP;
	TForm		*FDSMPForm;
	TPanel		*PanelCaption;
	TPanel		*PanelDisplay;
	TPanel		*PanelTitle;
	TPanel		*PanelArtist;
	TPanel		*PanelDevice;
	AnsiString	FDesign;

	TPanel		*LyrPanel;
	TLabel		*LyrLabel;
	bool		FScrollLyrEnabled;
	bool		FDisplayPanel;
	bool		FColorKey;
	TColor		FColor;
	TColor		FPanelColor;
	double		FZoom;
	int			FontHeight;
	AnsiString	FontName;
	bool		FontChange;
	TFontStyle	FontStyle;

	TPanel*		FScrollPanel[SCROLLPANELMAX+1];
	TLabel*		FScrollLabel[SCROLLPANELMAX+1];
	int			FScrollType[SCROLLPANELMAX+1];
	bool		FScrollChecked[SCROLLPANELMAX+1];
	int			FScrollTime[SCROLLPANELMAX+1];
	int			FScrollCounter[SCROLLPANELMAX+1];
	int			FScrollStep[SCROLLPANELMAX+1];

protected:
	void __fastcall SetControl(TCControl *Control,TMemIniFile *File,AnsiString Section);
	void __fastcall	InitLabel(TLabel *Label);
	TLabel* __fastcall	MakePanel(AnsiString Name,TMemIniFile *File);
	void __fastcall	SetLabel(void);
	void __fastcall	DSMPOnUser(TObject* Sender,DWORD Event,int Param);
	void __fastcall DSMPOnOpenTrack(TObject *Sender, int Track);
	void __fastcall DSMPOnCloseTrack(TObject *Sender, int Track);
	void __fastcall	DSMPOnLoadLyrics(TObject* Sender);
	void __fastcall DSMPOnLyrics(TObject* Sender,int Param);
	void __fastcall DSMPOnDisplayTitle(TObject* Sender,int Param);
	void __fastcall DSMPOnDisplayCaption(TObject* Sender);
	void __fastcall DSMPOnIntTimer(TObject* Sender,int Param);
	AnsiString __fastcall	GetFileName(bool f=false);
	void __fastcall SetScrollCaption(void);
	void __fastcall	Scroll(int n,int tm);

public:
	__fastcall	TLyrPanel(TComponent *Owner);
	__fastcall	~TLyrPanel(void);

	__property	TDSMP	*DSMP={read=FDSMP};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	TDSMPInterface	*DSMPIntf;
extern	int				Version;
extern	TLyrPanel		*LyrPanel;

#endif

/*****	End	****/

