/*	Filename:main.cpp							*/
/************************************************/
/*												*/
/*					WXyAipl+	  		*/
/*												*/
/*					Ver.6.31  					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 2001,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "main.h"
#include "math.hpp"
#include "math.h"
#include "fileinfo.h"

#pragma package(smart_init)

//#define	crHandCursor	((TCursor)(16))
#define SAMPLES 		2048                //Wave Samples

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TDSMPInterface	*DSMPIntf;
int				Version=6108;
HANDLE			hMutex;
TWSpeana		*WSpeana;

/*----------------------------------------------*/
/*				GNX|[g					*/
/*----------------------------------------------*/

/*****	vOC̎s	*****/

void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if ((DSMPIntf->CheckVersion(DSMP_DLLVERSION)==false)
		OR (DSMPIntf->GetVersion()<DSMP_VERSION))
	then {
		MessageDlg("WSpeana+\n\ño[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);
		DSMPIntf->Abort();
		return;
	}
	hMutex=::CreateMutex(NULL,FALSE,"WSpeana");
	if ((hMutex==0) OR (::GetLastError()==ERROR_ALREADY_EXISTS))
	then {
		DSMPIntf->Abort();		  					//2dNȂI
		return;
	}

	WSpeana=new TWSpeana(DSMPIntf->GetPlayerForm());
}

/*****	vOC̏I	*****/

void	pinAbort(void)
{
	if (WSpeana)
	then {
		delete	WSpeana;
		WSpeana=NULL;
	}

	if (hMutex)
	then {
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		hMutex=0;
	}
}

/*****	TvOtB^[	*****/

WAVEHDR* pinSampling(WAVEHDR *WaveHeader)
{
	if (WSpeana)
	then	WSpeana->DSMPOnSampling(WaveHeader);

	return(WaveHeader);
}

/*----------------------------------------------*/
/*				TSpeanaPanelNX 				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TWSpeana::TWSpeana(TComponent *Owner)
:TComponent(Owner)
{
	AnsiString	S;
	int			i;
	TColor		c;

	FDSMP=new TDSMP(Owner);
	FDSMP->Bind();

	FFTLrbf=new char[sizeof(double)*SAMPLES+16];
	FFTLibf=new char[sizeof(double)*SAMPLES+16];
	FFTLr=(double *)((DWORD(FFTLrbf)+15) & 0xFFFFFFF0);              //pOtE
	FFTLi=(double *)((DWORD(FFTLibf)+15) & 0xFFFFFFF0);
	FFTRrbf=new char[sizeof(double)*SAMPLES+16];
	FFTRibf=new char[sizeof(double)*SAMPLES+16];
	FFTRr=(double *)((DWORD(FFTRrbf)+15) & 0xFFFFFFF0);              //pOtE
	FFTRi=(double *)((DWORD(FFTRibf)+15) & 0xFFFFFFF0);
	MakeSinCos(SAMPLES);

	FDSMPForm=(TForm*)DSMPIntf->GetControl(DSMP_ID_FORM);
	FDSMPSpeana=(TPanel*)DSMPIntf->GetControl(DSMP_ID_SPEANA);

	FSpeanaPanelL=new TSpeanaPanel(FDSMPForm);
	FSpeanaPanelR=new TSpeanaPanel(FDSMPForm);
	FSpeanaPanelL->OnClick=SpeanaPanelClick;
	FSpeanaPanelR->OnClick=SpeanaPanelClick;

	TStringList	*SList=new TStringList();
	TIniFile	*File=new TIniFile(DSMP->Design);

	AnsiString	DesignDir=ExtractFileDir(DSMP->Design);

	FSpeanaPanelL->Visible=File->ReadInteger("SpeanaL","Visible",false);
	FSpeanaPanelL->Left=File->ReadInteger("SpeanaL","Left",0);
	FSpeanaPanelL->Top=File->ReadInteger("SpeanaL","Top",0);
	FSpeanaPanelL->Width=File->ReadInteger("SpeanaL","Width",0);
	FSpeanaPanelL->Height=File->ReadInteger("SpeanaL","Height",0);
	FSpeanaPanelL->BevelInner=(TBevelCut)File->ReadInteger("SpeanaL","EdgeInner",0);
	FSpeanaPanelL->BevelOuter=(TBevelCut)File->ReadInteger("SpeanaL","EdgeOuter",0);
	FSpeanaPanelL->Color=(TColor)File->ReadInteger("SpeanaL","BackColor",0);
	if (File->ReadBool("SpeanaL","Checked",false))
	then	FSpeanaPanelL->Type=mtGraphics;
	else	FSpeanaPanelL->Type=mtLevel;
	SList->CommaText=AnsiLowerCase(File->ReadString("SpeanaL","Option",""));
	FSpeanaPanelL->Dir=File->ReadInteger("SpeanaL","Type",0);
	S=SList->Values["dir"];											//݊̈
	if (!S.IsEmpty())
	then	FSpeanaPanelR->Dir=S.ToIntDef(FSpeanaPanelL->Dir);
/*
	S=SList->Values["type"];
	if (S=="mask")
	then	FSpeanaPanelL->Type=mtMask;
	else if (S=="graphics")
	then	FSpeanaPanelL->Type=mtGraphics;
	else	FSpeanaPanelL->Type=mtLevel;
*/
	S=AbsPath(File->ReadString("SpeanaL","Graphics",""),DesignDir);
	FSpeanaPanelL->Graphics=S;

	FSpeanaPanelR->Visible=File->ReadInteger("SpeanaR","Visible",false);
	FSpeanaPanelR->Left=File->ReadInteger("SpeanaR","Left",0);
	FSpeanaPanelR->Top=File->ReadInteger("SpeanaR","Top",0);
	FSpeanaPanelR->Width=File->ReadInteger("SpeanaR","Width",0);
	FSpeanaPanelR->Height=File->ReadInteger("SpeanaR","Height",0);
	FSpeanaPanelR->BevelInner=(TBevelCut)File->ReadInteger("SpeanaR","EdgeInner",0);
	FSpeanaPanelR->BevelOuter=(TBevelCut)File->ReadInteger("SpeanaR","EdgeOuter",0);
	FSpeanaPanelR->Color=(TColor)File->ReadInteger("SpeanaR","BackColor",0);
	if (File->ReadBool("SpeanaR","Checked",false))
	then	FSpeanaPanelR->Type=mtGraphics;
	else	FSpeanaPanelR->Type=mtLevel;
	SList->CommaText=AnsiLowerCase(File->ReadString("SpeanaR","Option",""));
	FSpeanaPanelR->Dir=File->ReadInteger("SpeanaR","Type",0);
	S=SList->Values["dir"];											//݊̈
	if (!S.IsEmpty())
	then	FSpeanaPanelR->Dir=S.ToIntDef(FSpeanaPanelR->Dir);
/*
	S=SList->Values["type"];
	if (S=="mask")
	then	FSpeanaPanelR->Type=mtMask;
	else if (S=="graphics")
	then	FSpeanaPanelR->Type=mtGraphics;
	else	FSpeanaPanelR->Type=mtLevel;
*/
	S=AbsPath(File->ReadString("SpeanaR","Graphics",""),DesignDir);
	FSpeanaPanelR->Graphics=S;

	SList->CommaText=File->ReadString("Lyrics","Colors","16776960,16776960,16776960,16776960,16776960,16776960,65535,65535,255,255");

	DSMPIntf->SetControlID(FSpeanaPanelL);
	DSMPIntf->SetControlID(FSpeanaPanelR);
	FSpeanaPanelL->Remake();
	FSpeanaPanelR->Remake();

	while(SList->Count<10)
	{
		SList->Add("255");
	}
	for(i=0;	i<10;	i++)
	{
		c=(TColor)SList->Strings[i].ToIntDef(255);
		FSpeanaPanelL->LevelColor[i]=c;
		FSpeanaPanelR->LevelColor[i]=c;
	}

	delete	File;
	delete	SList;

	DSMPOnSaveDSMPini(this);
	FRecordingLevel=FDSMP->RecLevel;
	FAdjustSpeana=FDSMP->AdjustSpeanaLevel;

	FDSMP->OnSpeana=DSMPOnSpeana;
	FDSMP->OnVolume=DSMPOnVolume;
	FDSMP->OnSaveDSMPini=DSMPOnSaveDSMPini;
	FDSMP->OnChangeDisplayMode=DSMPOnChangeDisplayMode;
	FDSMP->OnUser=DSMPOnUser;
	FDSMP->OnPlayStatus=DSMPOnPlayStatus;
	FDSMP->OnAdjustLevel=DSMPOnAdjustLevel;

//XyAiCxgDSMPFFTs̃CxgʒmȂ悢
//OnSpeanagȂƃXyAi\̂鎖̂
//ςOnVolumeŃ{[0`FbN
//	DSMP->Events=TDSMPEventSets()<<evSpeana;
	DSMP->Events=TDSMPEventSets()<<evVolume;


/*
zCgAEgh~̂߁AgɃCxg𔭐āA
xDSMPɐ߂Aŕ\XV
*/
	DSMP->NotifyEvent(DSMP->Handle,DSMP_NOTIFY_USER | DSMP_NOTIFY_SPEANA,0);	//Modified Ver.3.332
}

/*****	fXgN^	*****/

__fastcall	TWSpeana::~TWSpeana(void)
{
	delete	FSpeanaPanelL;
	delete	FSpeanaPanelR;
	delete	FFTLrbf;
	delete	FFTLibf;
	delete	FFTRrbf;
	delete	FFTRibf;
	delete	Sinbf;
	delete	Cosbf;

	delete	FDSMP;
}

/*****	XyAiplNbN	*****/

void __fastcall	TWSpeana::SpeanaPanelClick(TObject *Sender)
{
	int	n=(int)FSpeanaPanelL->PeakType;

	n++;
	if (n>=4)
	then	n=1;
	if (n<1)
	then	n=1;

	FSpeanaPanelL->PeakType=(TPeakType)n;
	FSpeanaPanelR->PeakType=(TPeakType)n;

	if (FDSMP->DisplayMode>=dsmpDispSpeana)
	then	FDSMP->DisplayMode=(TDSMPDisplayMode)(n+1);
}

/*****	DSMP_NOTIFY_USER	*****/

void __fastcall	TWSpeana::DSMPOnUser(TObject* Sender,DWORD Event,int Param)
{
	if (Event==DSMP_NOTIFY_SPEANA)
	then {
		Clear();
	}
}

/*****	DSMP.iniZ[uꂽ	*****/

void __fastcall TWSpeana::DSMPOnSaveDSMPini(TObject* Sender)
{

	AnsiString	S=ChangeFileExt(DSMP->DSMPPath,".ini");

	TIniFile	*File=new TIniFile(S);

	FSpeanaPattern=File->ReadInteger("DSMP","SpeanaPattern",2);
	FDisplaySpeana=File->ReadInteger("DSMP","DisplaySpeana",1);
//	FRecordingLevel=File->ReadInteger("DSMP","RecodingLevel",100);
//	FAdjustSpeana=File->ReadInteger("DSMP","AdjustSpeana",100);

	delete	File;

	DSMPOnChangeDisplayMode(this,FDSMP->DisplayMode);
}

/*****	\[h̕ύX	*****/

void __fastcall	TWSpeana::DSMPOnChangeDisplayMode(TObject* Sender,TDSMPDisplayMode Mode)
{
	FDisplayMode=Mode;

	TPeakType	PeakType=FSpeanaPanelL->PeakType;

	switch(Mode)
	{
		case dsmpDispNone:
		case dsmpDispLyrics:
			break;
		case dsmpDispSpeana:
			PeakType=ptNone;
			break;
		case dsmpDispSpeanaPeak:
			PeakType=ptHold;
			break;
		case dsmpDispSpeanaDecay:
			PeakType=ptDecay;
			break;
	}
	FSpeanaPanelL->PeakType=PeakType;
	FSpeanaPanelR->PeakType=PeakType;
}

/*****	tԕύXCxg	*****/

void __fastcall TWSpeana::DSMPOnPlayStatus(TObject* Sender,int Param)
{
	FRecordingLevel=FDSMP->RecLevel;
}

/*****	{[Cxg	*****/

void __fastcall TWSpeana::DSMPOnVolume(TObject* Sender,int Left,int Right)
{
	if ((Left==0) AND (Right==0))
	then	Clear();
}

/*****	XyAi\Cxg	*****/

void __fastcall TWSpeana::DSMPOnSpeana(TObject* Sender,int *Level)
{
	int		i;

	for(i=0;	i<10;	i++)
	{
		if (Level[i])
		then	return;
	}
	Clear();
}

/*****	\Cxg	*****/

void __fastcall	TWSpeana::DSMPOnAdjustLevel(TObject* Sender,int Type)
{
	FRecordingLevel=FDSMP->RecLevel;
	FAdjustSpeana=FDSMP->AdjustSpeanaLevel;
}

/*****	TvOCxg	*****/

void __fastcall	TWSpeana::DSMPOnSampling(WAVEHDR *WaveHeader)
{
	int     		d,f,i,l,r;
    unsigned int    *Data;
	int     		Samples;

	FMaxL=0;									//̓xől
	FMaxR=0;									//gĂȂ

	if ((FSpeanaPanelL->Visible==false) AND (FSpeanaPanelR->Visible==false))
	then	return;

	f=true;
	if (FFFT)
    then    f=false;

    try {
        if (WaveHeader==NULL)
        then {
			if (f)
            then    goto L2;
            else    return;
		}
        Data=(unsigned int *)(WaveHeader->lpData);
		if (Data==NULL)
        then {
            if (f)
            then    goto L2;
            else    return;
        }
		Samples=(WaveHeader->dwBytesRecorded)/4;
        if (Samples>SAMPLES)
        then    Samples=SAMPLES;
        if ((Samples<0) OR (WaveHeader->dwBytesRecorded>WaveHeader->dwBufferLength))
        then {
            if (f)
            then    goto L2;
			else    return;
		}
    }
	catch(...)
    {
        if (f)
        then    goto L2;
        else    return;
    }

	if (FFFT)
	then	return;											//vZ

	FFFT=true;

	f=0;
	i=0;
    try {
//      if (FPlay==false)
//		then    goto L2;

		memset(FFTLi,0,SAMPLES*sizeof(double));
		memset(FFTRi,0,SAMPLES*sizeof(double));

		for(;   i<Samples;  i++)
        {
            d=Data[i];
			l=(short int)(LOWORD(d));
			r=(short int)(HIWORD(d));

			if (FRecordingLevel != 100)
			then {
				l=l*FRecordingLevel/100;
                r=r*FRecordingLevel/100;
				if (l<-32768)
                then    l=-32768;
                else if (l>=32768)
                then    l=32767;
                if (r<-32768)
				then    r=-32768;
                else if (r>=32768)
				then    r=32767;
			}

			if (FMaxL<abs(l))
			then    FMaxL=abs(l);
			if (FMaxR<abs(r))
			then    FMaxR=abs(r);

			FFTLr[i]=l;									//
			FFTRr[i]=r;
			f |=abs(l)+abs(r);							//̓x0̈
		}
	}
	catch(...)
    {
		goto L2;
    }
//L1:
	if (f & 0xFFFFFF00)									//̓xꍇ
	then {
		d=(SAMPLES-i)*sizeof(double);
		if (d)
		then {
			memset(&FFTLr[i],0,d);
			memset(&FFTRr[i],0,d);
		}
		Show(FSpeanaPanelL,FFTLr,FFTLi);
		Show(FSpeanaPanelR,FFTRr,FFTRi);
	}
	else {
L2:
		Clear();
	}
	FFFT=false;
}

/*****  XyAi\    *****/

void __fastcall TWSpeana::Show(TSpeanaPanel *SpeanaPanel,double *FFTr,double *FFTi)
{
	static  int Range[][11]=
    {
		{0,8,20,37,63,96,137,194,282,441,1024},         //p[CRCY
		{0,2,4,8,16,32,64,128,256,512,1024},            //WIgbN
        {0,10,15,20,30,40,60,80,120,160,1024},          //{[J
		{0,2,5,8,11,14,17,20,40,80,1024},               //oX
		{0,2,5,10,15,20,40,80,160,320,1024},            //~h
        {0,10,15,20,30,40,80,160,320,640,1024}          //gu
    };
	static  int     Ratio[][10]=
	{
        {70,66,76,78,83,76,70,80,73,65},                //p[CRCY
		{805,228,115,89,74,59,44,37,47,88},             //WIgbN
        {56,152,192,123,144,104,131,72,88,20},          //{[J
		{804,154,152,200,258,281,352,67,57,13},         //oX
		{802,156,99,152,192,67,58,40,41,40},            //~h
		{56,152,192,123,144,58,40,41,51,173}            //gu
    };
	int     	d,i;

	FFT1(FFTr,FFTi,SAMPLES,true);

/*----- XyAix\  -----*/

	for(i=0;    i<10;   i++)
	{
		d=GetBandPower(Range[FSpeanaPattern][i],Range[FSpeanaPattern][i+1],FFTr,FFTi);
		d=(double)d*1.6*Ratio[FSpeanaPattern][i]/10000000*FAdjustSpeana/100+0.5;
		if (d>=10)
		then	d=10;
		SpeanaPanel->Level[i]=d;
	}
	if (SpeanaPanel->Type==mtMask)
	then {
//		SpeanaPanel->Invalidate();
		SpeanaPanel->Update();
	}
}

/*****  XyAi\̃NA    *****/

void __fastcall TWSpeana::Clear(void)
{
	int     i,j;

	FSpeanaPanelL->Clear();
	FSpeanaPanelR->Clear();
}

/*****  1FFT    *****/
/*
	x=
	y=
    Samples=Tv
    Flag:true=FFT,false=Inv FFT
*/
void __fastcall TWSpeana::FFT1(double *x,double *y,int Samples,bool Flag)
{
    int     pow=Samples;
    int     num=1;
    int     len=Samples;
    int     tim;
    int     i,j,k,w,j1,j2;
    double  xr,xi,yr,yi,c,s;

    i=0;
    do {
        i++;
        pow>>=1;
	} while(pow>1);
    pow=i;

	for(i=0;    i<pow;  i++)
    {
        len /=2;
        tim=0;
		for(j=0;    j<num;  j++)
        {
            w=0;
            for(k=0;    k<len;  k++)
			{
                j1=tim+k;
                j2=j1+len;
                xr=x[j1];
                xi=y[j1];
                yr=x[j2];
                yi=y[j2];
                x[j1]=xr+yr;
                y[j1]=xi+yi;
                xr=xr-yr;
                xi=xi-yi;
                c=Cos[w];
                s=Sin[w];
                x[j2]=xr*c-xi*s;
                y[j2]=xr*s+xi*c;
                w+=num;
            }
            tim+=2*len;
		}
        num *=2;
    }

    for(i=0;    i<Samples;  i++)
    {
        w=0;
        k=i;
        for(j=0;    j<pow;  j++)
        {
			w=(w<<1) | (k & 1);
            k >>=1;
        }
        if (i<w)
        then {
            xr=x[i];
			yi=y[i];
            x[i]=x[w];
            y[i]=y[w];
            x[w]=xr;
            y[w]=yi;
        }

    }

    c=1.0/sqrt(Samples);
    for(i=0;    i<Samples;  i++)
    {
		x[i] *=c;
		y[i] *=c;
    }
}

/*****  ш̃p[擾  *****/

double __fastcall   TWSpeana::GetBandPower(int From,int To,double *FFTr,double *FFTi)
{
	int     i;
	double  n=0;

	for(i=From; i<To;   i++)
    {
		n+=sqrt(FFTr[i]*FFTr[i]+FFTi[i]*FFTi[i]);
	}
    return(n);
}

/*****  Sin,Cose[u̍쐬   *****/

void __fastcall TWSpeana::MakeSinCos(int Samples)
{
	if (Sinbf)
	then    delete  Sinbf;
	if (Cosbf)
	then    delete  Cosbf;
	Sinbf=new char[sizeof(double)*Samples+16];
	Cosbf=new char[sizeof(double)*Samples+16];
	Sin=(double *)((DWORD(Sinbf)+15) & 0xFFFFFFF0);
	Cos=(double *)((DWORD(Cosbf)+15) & 0xFFFFFFF0);

	int     i;
	Extended    s,c;
    Extended    w=(Extended)6.283185303/Samples;    //2*pi/Samples
	for(i=0;    i<Samples;  i++)
	{
		SinCos(i*w,s, c);
		Sin[i]=s;
        Cos[i]=c;
	}
}

/*****	End	*****/
