/*	Filename:DSMP.cpp							*/
/************************************************/
/*												*/
/*				DSMPC^[tF[X			*/
/*												*/
/*					Ver.6.32   					*/
/*												*/
/*			DSMPC^[tF[XW[		*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <registry.hpp>
#include <ComObj.hpp>
#pragma hdrstop

#include "DSMP.h"
#pragma package(smart_init)

/*
#define	then
#define	AND		&&
#define	OR		||
*/
/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TDSMPInterface	*DSMPIntf;

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	ۃNX`FbN	*****/
//
// ValidCtrCheck ́A`ꂽR|[lgz֐܂
// ۃNXł͂ȂƂmF邽߂ɒ`Ă܂B
//

static inline void ValidCtrCheck(TDSMP *)
{
	new TDSMP(NULL);
}

/*****	R|[lg̓o^	*****/

namespace Dsmp
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TDSMP)};
		RegisterComponents("DELTA", classes, 0);
	}
}

/*----------------------------------------------*/
/*				dll	Export֐					*/
/*----------------------------------------------*/

/*****	vOC̎s	*****/
/*
void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if (DllOnRun)
	then	DllOnRun();
}
*/
/*****	vOC̏I	*****/
/*
void	pinAbort(void)
{
	if (DllOnAbort)
	then	DllOnAbort();
}
*/
/*****	Cxgʒm	*****/
/*
void	pinNotifyEvent(int Event,int Param)
{
	if (DllOnEvent)
	then	DllOnEvent(Event,Param);
}
*/

/*----------------------------------------------*/
/*				TTrackInfoNX				*/
/*----------------------------------------------*/

__fastcall	TTrackInfo::TTrackInfo(void)
{
	Adjust=0;
	Length=0;
	Time=0;
	Device=dsmpUnknown;
	Drive=0;
	Track=0;
	Prev=0;
	Next=0;
	Tag=0;
}

/*****	Set(TTrackInfo &)	*****/

TTrackInfo& __fastcall	TTrackInfo::Set(const TTrackInfo& rhs)
{
	Title=rhs.Title;
	Artist=rhs.Artist;
	FileName=rhs.FileName;
	ArcName=rhs.ArcName;
	Lyrics=rhs.Lyrics;
	Adjust=rhs.Adjust;
	Length=rhs.Length;
	Time=rhs.Time;
	Device=rhs.Device;
	Track=rhs.Track;
	Drive=rhs.Drive;
	Prev=rhs.Prev;
	Next=rhs.Next;

	return(*this);
}

/*****	Set(TDSMPTrackInfo &)	*****/

TTrackInfo& __fastcall	TTrackInfo::Set(const TDSMPTrackInfo &rhs)
{
	Title=AnsiString(rhs.Title);
	Artist=AnsiString(rhs.Artist);
	FileName=AnsiString(rhs.FileName);
	ArcName=AnsiString(rhs.ArcName);
	Lyrics=AnsiString(rhs.Lyrics);
	Adjust=rhs.Adjust;
	Length=rhs.Length;
	Time=rhs.Time;
	Device=rhs.Device;
	Drive=HIWORD(rhs.Drive);
	Track=LOWORD(rhs.Drive);
	Prev=rhs.Prev;
	Next=rhs.Next;

//for DSMP Ver.3.303

	if (((Device==dsmpCD) OR (Device==dsmpCDA))
		AND ((Drive==0) OR (Track==0)))
	then {
		AnsiString	S=FileName.LowerCase();
		if ((S.Length()>=2) AND (S[2]==':'))
		then {
			Drive=S[1]-'a';
			if ((Drive>26) OR (Drive<0))
			then	Drive=0;
			int		n=S.AnsiPos("track");
			if (n)
			then {
				S=S.SubString(n+5,S.Length()-(n+5)+1);
				n=S.AnsiPos(".cda");
				if (n)
				then {
					S=S.SubString(1,n-1);
					Track=S.ToIntDef(0);
				}
			}
		}
	}

	return(*this);
}

/*****	TTrackInfoTDSMPTrackInfo	*****/

void __fastcall	TTrackInfo::ToDSMPTrackInfo(TDSMPTrackInfo *Info)
{
	Info->Title=WideString(Title).Copy();
	Info->Artist=WideString(Artist).Copy();
	Info->FileName=WideString(FileName).Copy();
	Info->ArcName=WideString(ArcName).Copy();
	Info->Lyrics=WideString(Lyrics).Copy();
	Info->Adjust=Adjust;
	Info->Length=Length;
	Info->Time=Time;
	Info->Device=Device;
	Info->Drive=Track | (Drive<<16);
	Info->Prev=Prev;
	Info->Next=Next;
}

/*----------------------------------------------*/
/*				TPlayListNX					*/
/*----------------------------------------------*/

/*****	RXgN^	******/

__fastcall	TPlayList::TPlayList(TDSMP *Owner)
{
	FDSMP=Owner;
}

/*****	C^[tF[X̎擾	*****/

TCOMIDSMPPlayList*	__fastcall	TPlayList::GetInterface(void)
{
	return(FDSMP->DSMPPlayList);
}

/*****	DSMPC^tF[XL	*****/

bool __fastcall	TPlayList::IsEnabled(void)
{
	return(FDSMP->Enabled);
}

/*****	gbN̎擾	*****/

TTrackInfo __fastcall	TPlayList::GetItems(int Track)
{
	TTrackInfo		TrackInfo;

	if (Enabled)
	then {
		TDSMPTrackInfo	Info;

		(*Interface)->GetTrack(Track,
			&Info.Title,
			&Info.Artist,
			&Info.FileName,
			&Info.ArcName,
			&Info.Lyrics,
			&Info.Adjust,
			&Info.Length,
			&Info.Time,
			&Info.Device,
			&Info.Drive,
			&Info.Prev,
			&Info.Next);

		TrackInfo=Info;
	}

	return(TrackInfo);
}

/*****	gbN̐ݒ	*****/

void __fastcall	TPlayList::SetItems(int Track,TTrackInfo Info)
{
	if (Enabled)
	then {
		TDSMPTrackInfo	dsmpInfo;

		Info.ToDSMPTrackInfo(&dsmpInfo);

		(*Interface)->SetTrack(Track,
			dsmpInfo.Title,
			dsmpInfo.Artist,
			dsmpInfo.FileName,
			dsmpInfo.ArcName,
			dsmpInfo.Lyrics,
			dsmpInfo.Adjust,
			dsmpInfo.Length,
			dsmpInfo.Time,
			dsmpInfo.Device,
			dsmpInfo.Drive,
			dsmpInfo.Prev,
			dsmpInfo.Next);
	}
}

/*****	gbN̎擾	*****/

int __fastcall	TPlayList::GetTracks(void)
{
	if (Enabled)
	then	return((*Interface)->Tracks);
	else	return(0);
}

/*****	GfBbgtO̎擾	*****/

bool __fastcall	TPlayList::GetEdited(void)
{
	if (Enabled)
	then	return((*Interface)->Edited);
	else	return(false);
}

/*****	GfBbgtO̐ݒ	*****/

void __fastcall	TPlayList::SetEdited(bool f)
{
	if (Enabled)
	then	(*Interface)->Edited=f;
}

/*****	vCXg^Cg̎擾	*****/

AnsiString __fastcall	TPlayList::GetTitle(void)
{
	if (Enabled)
	then	return((*Interface)->PlayListTitle);
	else	return("");
}

/*****	vCXg^Cg̐ݒ	*****/

void __fastcall	TPlayList::SetTitle(AnsiString Title)
{
	if (Enabled)
	then	(*Interface)->set_PlayListTitle(WideString(Title).Copy());
}

/*****	fUC̎擾	*****/

AnsiString __fastcall	TPlayList::GetDesign(void)
{
	if (Enabled)
	then	return((*Interface)->PlayListDesign);
	else	return("");
}

/*****	fUC̐ݒ	*****/

void __fastcall	TPlayList::SetDesign(AnsiString Path)
{
	if (Enabled)
	then	(*Interface)->set_PlayListDesign(WideString(Path).Copy());
}

/*****	VK쐬	*****/

void __fastcall	TPlayList::New(void)
{
	if (Enabled)
	then	(*Interface)->New();
}

/*****	gbN̑}	*****/

void __fastcall	TPlayList::Insert(int Track)
{
	if (Enabled)
	then	(*Interface)->Insert(Track);
}

/*****	gbN̍폜	*****/

void __fastcall	TPlayList::Delete(int Track)
{
	if (Enabled)
	then	(*Interface)->Delete(Track);
}

/*****	t@C̒ǉ	*****/

void __fastcall	TPlayList::Add(AnsiString FileName)
{
	if (Enabled)
	then	(*Interface)->Add(WideString(FileName).Copy());
}

/*****	t@C̃[h	*****/

void __fastcall	TPlayList::Load(AnsiString Path)
{
	if (Enabled)
	then	(*Interface)->Load(WideString(Path).Copy());
}

/*****	vCXg̃Z[u	*****/

void __fastcall	TPlayList::Save(AnsiString Path)
{
	if (Enabled)
	then	(*Interface)->Save(WideString(Path).Copy());
}

/*****	̎t@C̕ҏW	*****/

void __fastcall	TPlayList::EditLyrics(int track)
{
	if (Enabled)
	then {
		TTrackInfo	Info=Items[track];
		(*Interface)->EditLyrics(WideString(Info.Lyrics).Copy());
	}
}

/*****	̎t@C̕ҏW	*****/

void __fastcall	TPlayList::EditLyrics(AnsiString Path)
{
	if (Enabled)
	then	(*Interface)->EditLyrics(WideString(Path).Copy());
}

/*****	tJngbN̎擾	*****/

int __fastcall	TPlayList::GetFirst(void)
{
	if (Enabled)
	then	return((*Interface)->FirstTrack);
	return(0);
}

/*****	tIgbN̎擾	*****/

int __fastcall	TPlayList::GetLast(void)
{
	if (Enabled)
	then	return((*Interface)->LastTrack);
	return(0);
}

/*****	vCXgt@C̎擾	*****/

AnsiString __fastcall	TPlayList::GetFileName(void)
{
	if (Enabled)
	then	return((*Interface)->PlayListName);
	return("");
}

/*****	ANeBugbN̎擾	*****/

int __fastcall	TPlayList::GetTrack(void)
{
	if (Enabled)
	then	return(FDSMP->Track);
	return(0);
}

/*****	RepeatJngbN̎擾	*****/

int __fastcall	TPlayList::GetRepeatFrom(void)
{
	if (Enabled)
	then	return((*Interface)->RepeatFrom);
	return(0);
}

/*****	RepeatJngbN̐ݒ	*****/

void __fastcall	TPlayList::SetRepeatFrom(int Track)
{
	if (Enabled)
	then	(*Interface)->RepeatFrom=Track;
}

/*****	RepeatIgbN̎擾	*****/

int __fastcall	TPlayList::GetRepeatTo(void)
{
	if (Enabled)
	then	return((*Interface)->RepeatTo);
	return(0);
}

/*****	RepeatIgbN̐ݒ	*****/

void __fastcall	TPlayList::SetRepeatTo(int Track)
{
	if (Enabled)
	then	(*Interface)->RepeatTo=Track;
}

/*****	IgbN̎擾	*****/

int __fastcall	TPlayList::GetSelected(void)
{
	if (Enabled)
	then	return((*Interface)->SelectedTrack);

	return(-1);
}

/*****	IgbN̐ݒ	*****/

void __fastcall	TPlayList::SetSelected(int Track)
{
	if (Enabled)
	then	(*Interface)->SelectedTrack=Track;
}

/*****	\Ԃ̎擾	*****/

bool __fastcall	TPlayList::GetVisible(void)
{
	if (Enabled)
	then	return((*Interface)->PlayListVisible);

	return(false);
}

/*****	\Ԃ̐ݒ	*****/

void __fastcall	TPlayList::SetVisible(bool f)
{
	if (Enabled)
	then	(*Interface)->PlayListVisible=f;
}

/*----------------------------------------------*/
/*				TLyricsNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TLyrics::TLyrics(void)
{
	Init();
}

/*****	RXgN^	*****/

__fastcall	TLyrics::TLyrics(TLyrics *Lyr)
{
	Init();
	Assign(Lyr);
}

/*****		*****/

void __fastcall	TLyrics::Init(void)
{
	Time=-1;
	Alignment=taCenter;
	WordWrap=true;
	ShowAccelChar=false;
	Tag=0;
	FFont=new TFont();
}

/*****	fXgN^	*****/

__fastcall	TLyrics::~TLyrics(void)
{
	delete	FFont;
}

/*****	tHg̐ݒ	*****/

void __fastcall	TLyrics::SetFont(TFont *Font)
{
	FFont->Assign(Font);
}

/*****	Assign	*****/

void __fastcall TLyrics::Assign(TLyrics* rhs)
{
	Time=rhs->Time;
	Text=rhs->Text;
	Alignment=rhs->Alignment;
	WordWrap=rhs->WordWrap;
	ShowAccelChar=rhs->ShowAccelChar;
	SetFont(rhs->Font);
	BackColor=rhs->BackColor;
}

/*****	Set(TLyrics&)	*****/

TLyrics& __fastcall TLyrics::Set(TLyrics& rhs)
{
	Assign(&rhs);

	return(*this);
}

/*****	Set(TDSMPLyrics&)	*****/

TLyrics& __fastcall TLyrics::Set(TDSMPLyrics& rhs)
{
	Time=rhs.Time;
	Text=rhs.Text;
	Alignment=(TAlignment)rhs.Alignment;
	WordWrap=rhs.WordWrap;
	ShowAccelChar=rhs.ShowAccelChar;
	FFont->Name=rhs.FontName;
	FFont->Charset=(TFontCharset)rhs.Charset;
	if (rhs.Size<0)
	then	FFont->Height=rhs.Size;
	else	FFont->Size=rhs.Size;
	FFont->Style=FFont->Style.Clear();
	if (rhs.Style & dsmpBold)
	then	FFont->Style=FFont->Style<<fsBold;
	if (rhs.Style & dsmpItalic)
	then	FFont->Style=FFont->Style<<fsItalic;
	if (rhs.Style & dsmpUnderline)
	then	FFont->Style=FFont->Style<<fsUnderline;
	if (rhs.Style & dsmpStrikeOut)
	then	FFont->Style=FFont->Style<<fsStrikeOut;
	FFont->Color=(TColor)rhs.Color;
	BackColor=(TColor)rhs.BackColor;

	return(*this);
}

/*****	operator = TLyrics&	*****/

TLyrics& __fastcall TLyrics::operator =(TLyrics& rhs)
{
	return(Set(rhs));
}

/*****	operator = TDSMPLyrics&	*****/

TLyrics& __fastcall	TLyrics::operator =(TDSMPLyrics& rhs)
{
	return(Set(rhs));
}

/*****	TLyricsTDSMPLyrics	*****/

void __fastcall	TLyrics::ToDSMPLyrics(TDSMPLyrics *Lyr)
{
	Lyr->Time=Time;
	Lyr->Text=WideString(Text).Copy();
	Lyr->WordWrap=WordWrap;
	Lyr->Alignment=(TDSMPAlignment)Alignment;
	Lyr->FontName=WideString(Font->Name).Copy();
	Lyr->Charset=Font->Charset;
	Lyr->Size=Font->Height;
	Lyr->Style=(TDSMPFontStyle)0;
	if (Font->Style.Contains(fsBold))
	then	Lyr->Style=(TDSMPFontStyle)(Lyr->Style | dsmpBold);
	if (Font->Style.Contains(fsItalic))
	then	Lyr->Style=(TDSMPFontStyle)(Lyr->Style | dsmpItalic);
	if (Font->Style.Contains(fsUnderline))
	then	Lyr->Style=(TDSMPFontStyle)(Lyr->Style | dsmpUnderline);
	if (Font->Style.Contains(fsStrikeOut))
	then	Lyr->Style=(TDSMPFontStyle)(Lyr->Style | dsmpStrikeOut);
	Lyr->Color=Font->Color;
	Lyr->BackColor=BackColor;
}

/*----------------------------------------------*/
/*				TLyricsListNX				*/
/*----------------------------------------------*/

/*****	RXgN^	******/

__fastcall	TLyricsList::TLyricsList(TDSMP *Owner)
{
	FDSMP=Owner;
	FList=new TList();
}

/*****	fXgN^	******/

__fastcall	TLyricsList::~TLyricsList()
{
	Clear();
	delete	FList;
}

/*****	Xg̃NA	*****/

void __fastcall	TLyricsList::Clear(void)
{
	int		i;

	for(i=0;	i<FList->Count;	i++)
	{
		TLyrics	*Lyr=(TLyrics*)(FList->Items[i]);
		if (Lyr)
		then	delete	Lyr;
	}
	FList->Clear();
}

/*****	C^[tF[X̎擾	*****/

TCOMIDSMPLyrics*	__fastcall	TLyricsList::GetInterface(void)
{
	return(FDSMP->DSMPLyrics);
}

/*****	DSMPC^tF[XL	*****/

bool __fastcall	TLyricsList::IsEnabled(void)
{
	return(FDSMP->Enabled);
}

/*****	s̎擾	*****/

TLyrics* __fastcall	TLyricsList::GetItems(int line)
{
	TLyrics	*Lyr;

	if ((line<0) OR (line>=Lines))
	then	return(NULL);

	if (Enabled)
	then {
		TDSMPLyrics	dsmpLyr;

		(*Interface)->GetLyrics(line,
			&dsmpLyr.Time,
			&dsmpLyr.Text,
			&dsmpLyr.Alignment,
			(VARIANT_BOOL*)&dsmpLyr.WordWrap,
			&dsmpLyr.FontName,
			&dsmpLyr.Charset,
			&dsmpLyr.Size,
			&dsmpLyr.Style,
			&dsmpLyr.Color,
			&dsmpLyr.BackColor);

		Lyr=(TLyrics*)(FList->Items[line]);
		if (Lyr==NULL)
		then {
			Lyr=new TLyrics();
			FList->Items[line]=Lyr;
		}
		Lyr->Set(dsmpLyr);
	}
	else {
		Lyr=(TLyrics*)(FList->Items[line]);
		if (Lyr==NULL)
		then {
			Lyr=new TLyrics();
			FList->Items[line]=Lyr;
		}
	}

	return(Lyr);
}

/*****	s̐ݒ	*****/

void __fastcall	TLyricsList::SetItems(int line,TLyrics* Lyr)
{
	if (Enabled)
	then {
		TDSMPLyrics	dsmpLyr;
		Lyr->ToDSMPLyrics(&dsmpLyr);

		(*Interface)->SetLyrics(line,dsmpLyr.Time,dsmpLyr.Text,dsmpLyr.Alignment,dsmpLyr.WordWrap,dsmpLyr.FontName,dsmpLyr.Charset,dsmpLyr.Size,dsmpLyr.Style,dsmpLyr.Color,dsmpLyr.BackColor);
	}
}

/*****	C̐ݒ	*****/

int __fastcall	TLyricsList::GetLines(void)
{
	int		n;

	if (Enabled)
	then	n=(*Interface)->Lines;
	else	n=0;

	if (n != FList->Count)
	then	FList->Count=n;

	return(n);
}

/*****	\̍s̎擾	*****/

int __fastcall	TLyricsList::GetLine(void)
{
	if (Enabled)
	then	return((*Interface)->Line);
	return(0);
}

/*****	\tO̎擾	*****/

bool __fastcall	TLyricsList::GetVisible(void)
{
	if (Enabled)
	then	return((*Interface)->VisibleLyrics);
	return(false);
}

/******	ANZ[^[LN^\tO̎擾	*****/

bool __fastcall	TLyricsList::GetShowAccelChar(void)
{
	if (Enabled)
	then	return((*Interface)->ShowAccelChar);
	return(false);
}

/*****	\l̎擾	*****/

int __fastcall	TLyricsList::GetAdjust(void)
{
	if (Enabled)
	then	return((*Interface)->Adjust);
	return(0);
}

/*****	^Cg̎擾	*****/

AnsiString __fastcall	TLyricsList::GetTitle(void)
{
	if (Enabled)
	then	return((*Interface)->LyricsTitle);
	return("");
}

/*****	A[eBXg̎擾	*****/

AnsiString __fastcall	TLyricsList::GetArtist(void)
{
	if (Enabled)
	then	return((*Interface)->LyricsArtist);
	return("");
}

/*****	쎌Ɩ̎擾	*****/

AnsiString __fastcall	TLyricsList::GetLyrics(void)
{
	if (Enabled)
	then	return((*Interface)->Lyrics);
	return("");
}

/*****	ȉƖ̎擾	*****/

AnsiString __fastcall	TLyricsList::GetMusic(void)
{
	if (Enabled)
	then	return((*Interface)->Music);
	return("");
}

/*****	҂̎擾	*****/

AnsiString __fastcall	TLyricsList::GetPresenter(void)
{
	if (Enabled)
	then	return((*Interface)->Presenter);
	return("");
}

/*****	Rg擾	*****/

AnsiString __fastcall	TLyricsList::GetComment(void)
{
	if (Enabled)
	then	return((*Interface)->Comment);
	return("");
}

/*****	̎plWidth̎擾	*****/

int __fastcall	TLyricsList::GetWidth(void)
{
	if (Enabled)
	then	return((*Interface)->LyricsWidth);
	return(246);
}

/*****	̎plHeight̎擾	*****/

int __fastcall	TLyricsList::GetHeight(void)
{
	if (Enabled)
	then	return((*Interface)->LyricsHeight);
	return(38);
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TLyricsList::GetFileName(void)
{
	if (Enabled)
	then	return((*Interface)->LyricsName);
	return("");
}

/*****	}	*****/

void __fastcall	TLyricsList::Insert(int line,TLyrics *Lyr)
{
	if (Enabled)
	then {
		TDSMPLyrics	dsmpLyr;
		Lyr->ToDSMPLyrics(&dsmpLyr);

		(*Interface)->InsertLyrics(line,dsmpLyr.Time,dsmpLyr.Text,dsmpLyr.Alignment,dsmpLyr.WordWrap,dsmpLyr.FontName,dsmpLyr.Charset,dsmpLyr.Size,dsmpLyr.Style,dsmpLyr.Color,dsmpLyr.BackColor);
	}
}

/*****	ǉ	*****/

void __fastcall	TLyricsList::Add(TLyrics *Lyr)
{
	if (Enabled)
	then {
		TDSMPLyrics	dsmpLyr;
		Lyr->ToDSMPLyrics(&dsmpLyr);

		(*Interface)->AddLyrics(dsmpLyr.Time,dsmpLyr.Text,dsmpLyr.Alignment,dsmpLyr.WordWrap,dsmpLyr.FontName,dsmpLyr.Charset,dsmpLyr.Size,dsmpLyr.Style,dsmpLyr.Color,dsmpLyr.BackColor);
	}
}

/*****	폜	*****/

void __fastcall	TLyricsList::Delete(int line)
{
	if (Enabled)
	then	(*Interface)->DeleteLyrics(line);
}

/*****	[h	*****/

void __fastcall	TLyricsList::Load(AnsiString Path)
{
	if (Enabled)
	then	(*Interface)->LoadLyrics(WideString(Path).Copy());
}

/*----------------------------------------------*/
/*				 TDSMPMenuNX				*/
/*----------------------------------------------*/

/******	RXgN^	*****/

__fastcall	TDSMPMenu::TDSMPMenu(TDSMP *Owner,long Handle)
	:TComponent(Owner)
{
	FDSMP=Owner;
	FDSMPHandle=Handle;
}

/*****	fXgN^	*****/

__fastcall	TDSMPMenu::~TDSMPMenu(void)
{
	if (FMaked)
	then {
		FDSMP->RemoveMenu(this);
		if (Interface)
		then	(*Interface)->RemoveMenu(FDSMPHandle);
		FDSMP->RemoveMenu(this);							//FailSafe
	}
}

/*****	C^[tF[X̎擾	*****/

TCOMIDSMPMenu*	__fastcall	TDSMPMenu::GetInterface(void)
{
	if (FDSMP->Enabled)
	then	return(FDSMP->DSMPMenu);

	return(NULL);
}

/*****	j[L؂	*****/

bool __fastcall	TDSMPMenu::GetAllocated(void)
{
	VARIANT_BOOL	f;

	if (Interface)
	then	(*Interface)->IsMenuAllocated(FDSMPHandle,(VARIANT_BOOL*)&f);
	else	f=false;

	return(f);
}

/*****	j[nh̎擾	*****/

HMENU __fastcall	TDSMPMenu::GetHandle(void)
{
	HMENU	Handle;

	if (Interface)
	then	(*Interface)->GetMenuHandle(FDSMPHandle,(long*)&Handle);
	else	Handle=0;

	return(Handle);
}

/*****	j[CfbNX̎擾	*****/

int __fastcall	TDSMPMenu::GetMenuIndex(void)
{
	long     Index;

	if (Interface)
	then	(*Interface)->GetMenuIndex(FDSMPHandle,&Index);
	else	Index=0;

	return(Index);
}

/*****	LvV̎擾	*****/

AnsiString __fastcall	TDSMPMenu::GetCaption(void)
{
	if (Interface)
	then {
		BSTR	S;
		(*Interface)->GetMenuText(FDSMPHandle,&S);
		return(AnsiString(S));
	}
	return("");
}

/*****	LvV̐ݒ	*****/

void __fastcall	TDSMPMenu::SetCaption(AnsiString caption)
{
	BSTR	S=WideString(caption).Copy();

	if (Interface)
	then	(*Interface)->SetMenuText(FDSMPHandle,S);
}

/*****	V[gJbg̎擾	*****/

TShortCut __fastcall	TDSMPMenu::GetShortCut(void)
{
	long	n;

	if (Interface)
	then	(*Interface)->GetMenuShortCut(FDSMPHandle,&n);
	else	n=0;

	return((TShortCut)n);
}

/*****	V[gJbg̐ݒ	*****/

void __fastcall	TDSMPMenu::SetShortCut(TShortCut Key)
{
	if (Interface)
	then	(*Interface)->SetMenuShortCut(FDSMPHandle,(long)Key);
}

/*****	ej[̎擾	*****/

TDSMPMenu* __fastcall	TDSMPMenu::GetParent(void)
{
	long	Handle;

	if (Interface)
	then {
		(*Interface)->GetParentMenu(FDSMPHandle,&Handle);
		return(FDSMP->GetMenu(Handle));
	}
	return(NULL);
}

/*****	Tuj[̎擾	*****/

int __fastcall	TDSMPMenu::GetCount(void)
{
	long	count;

	if (Interface)
	then	(*Interface)->GetMenus(FDSMPHandle,&count);
	else	count=0;

	return(count);
}

/*****	Tuj[̎擾	*****/

TDSMPMenu* __fastcall	TDSMPMenu::GetItem(int Index)
{
	long		Handle;

	if (Interface)
	then {
		(*Interface)->GetMenu(FDSMPHandle,Index,&Handle);
		return(FDSMP->GetMenu(Handle));
	}
	return(NULL);
}

/*****	I\Ԃ̎擾	*****/

bool __fastcall	TDSMPMenu::GetEnabled(void)
{
	VARIANT_BOOL	f;

	if (Interface)
	then	(*Interface)->GetMenuEnabled(FDSMPHandle,(VARIANT_BOOL*)&f);
	else	f=false;

	return(f);
}

/*****	I\Ԃ̐ݒ	*****/

void __fastcall	TDSMPMenu::SetEnabled(bool f)
{
	if (Interface)
	then	(*Interface)->SetMenuEnabled(FDSMPHandle,f);
}

/****	`FbNԂ̎擾	*****/

bool __fastcall	TDSMPMenu::GetChecked(void)
{
	VARIANT_BOOL	f;

	if (Interface)
	then	(*Interface)->GetMenuChecked(FDSMPHandle,(VARIANT_BOOL*)&f);
	else	f=false;

	return(f);
}

/*****	`FbNԂ̐ݒ	*****/

void __fastcall	TDSMPMenu::SetChecked(bool f)
{
	if (Interface)
	then	(*Interface)->SetMenuChecked(FDSMPHandle,f);
}

/*****	\Ԃ̎擾	*****/

bool __fastcall	TDSMPMenu::GetVisible(void)
{
	VARIANT_BOOL	f;

	if (Interface)
	then	(*Interface)->GetMenuVisible(FDSMPHandle,(VARIANT_BOOL*)&f);
	else	f=false;

	return(f);
}

/*****	\Ԃ̐ݒ	*****/

void __fastcall	TDSMPMenu::SetVisible(bool f)
{
	if (Interface)
	then	(*Interface)->SetMenuVisible(FDSMPHandle,f);
}

/*****	Tuj[̒ǉ	*****/

TDSMPMenu* __fastcall	TDSMPMenu::Add(AnsiString Caption)
{
	BSTR	S=WideString(Caption).Copy();
	long	Handle;

	if (Interface)
	then	 {
		(*Interface)->AddMenu((long)FDSMP->Handle,FDSMPHandle,S,&Handle);

		TDSMPMenu	*Menu=FDSMP->GetMenu(Handle);
		Menu->Maked=true;
		return(Menu);
	}
	return(NULL);
}

/*****	Tuj[̑}	*****/

TDSMPMenu* __fastcall	TDSMPMenu::Insert(int Index,AnsiString Caption)
{
	if (Interface)
	then {
		BSTR	S=WideString(Caption).Copy();
		long	Handle;

		(*Interface)->InsertMenu((long)FDSMP->Handle,FDSMPHandle,Index,S,&Handle);

		TDSMPMenu	*Menu=FDSMP->GetMenu(Handle);
		Menu->Maked=true;
		return(Menu);
	}
	return(NULL);
}

/*****	j[̍폜	*****/

void __fastcall	TDSMPMenu::Delete(int Index)
{
	if (Interface)
	then {
		TDSMPMenu	*Menu=GetItem(Index);

		(*Interface)->DeleteMenu(FDSMPHandle,Index);

		FDSMP->DeleteMenu(Menu);
	}
}

/*****	j[̍폜	*****/

void __fastcall	TDSMPMenu::Remove(TDSMPMenu *Menu)
{
	if (Interface)
	then {
		(*Interface)->RemoveMenu(Menu->FDSMPHandle);

		FDSMP->DeleteMenu(Menu);
	}
}

/*****	j[̃T[`	*****/

TDSMPMenu* __fastcall	TDSMPMenu::Find(AnsiString Caption)
{
	if (Interface)
	then {
		BSTR	S=WideString(Caption).Copy();
		long	Handle;

		(*Interface)->FindMenu(FDSMPHandle,S,&Handle);

		return(FDSMP->GetMenu(Handle));
	}
	return(NULL);
}

/*****	j[̃NbN	*****/

void __fastcall	TDSMPMenu::Click(void)
{
	if (Interface)
	then	(*Interface)->ClickMenu(FDSMPHandle);
}


/*----------------------------------------------*/
/*				 TDSMPNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TDSMP::TDSMP(TComponent *AOwner)
:TComponent(AOwner)
{
	FAutoLink=true;
	FText=new TLyrics();
	FLyricsList=new TLyricsList(this);
	FPlayList=new TPlayList(this);
	FMenuList=new TList();
	FPlayerMenu=new TDSMPMenu(this,DSMP_MENU_PLAYER);
	FPlayListMenu=new TDSMPMenu(this,DSMP_MENU_PLAYLIST);
	FPlayListPopupMenu=new TDSMPMenu(this,DSMP_MENU_PLAYLISTPOPUP);
	FToolMenu=new TDSMPMenu(this,DSMP_MENU_TOOL);
	FFont=new TFont();

	FEvent=~(DSMP_NOTIFY_VOLUME | DSMP_NOTIFY_SPEANA | DSMP_NOTIFY_LYRICS
				| DSMP_NOTIFY_COUNTER | DSMP_NOTIFY_POSITION | DSMP_NOTIFY_TIMER | DSMP_NOTIFY_MOVE);

	FWM_DSMP=::RegisterWindowMessage("WM_DSMP");			//WM_DSMP擾

/*-----	DSMP.EXẼpX擾	-----*/

	FDSMPPath="";
	TRegistry	*Reg=new TRegistry();
	Reg->RootKey=HKEY_LOCAL_MACHINE;
	if (Reg->OpenKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DSMP.EXE",false))
	then {
		try {
			FDSMPPath=Reg->ReadString("");
		}
		catch(...)
		{
			FDSMPPath="";
		}
		Reg->CloseKey();
	}

	if (FDSMPPath.IsEmpty())
	then {
		Reg->RootKey=HKEY_CURRENT_USER;
		if (Reg->OpenKey("Software\\DELTA\\DSMP",false))
		then {
			try {
				FDSMPPath=Reg->ReadString("");
			}
			catch(...)
			{
				FDSMPPath="";
			}
			Reg->CloseKey();
		}
	}
	delete	Reg;

	FHandle=AllocateHWnd(WndProc);


	HRESULT hr=::CoInitialize(NULL);
	FCoInit=SUCCEEDED(hr);

	if (!ComponentState.Contains(csDesigning))
	then {
		GetDSMPHandle();
		::PostMessage(HWND_BROADCAST,FWM_DSMP,(WPARAM)DSMP_FIND,(LPARAM)FHandle);
	}
}

/*****	fXgN^	*****/

__fastcall	TDSMP::~TDSMP(void)
{
	Unbind();									//NN[Y

	if (FCoInit)
	then	::CoUninitialize();

	DeallocateHWnd(FHandle);

	delete	FFont;
	delete	FText;
	delete	FLyricsList;
	delete	FPlayList;
	delete	FPlayerMenu;
	delete	FPlayListMenu;
	delete	FPlayListPopupMenu;
	delete	FToolMenu;
	delete	FMenuList;
	FMenuList=NULL;
}

/*****	Loaded	****/

void __fastcall TDSMP::Loaded(void)
{
	if ((Enabled==false) AND (FAutoLink) AND (DSMPHandle))
	then	Bind();
}

/*****	EBhEvV[W\	*****/

void __fastcall	TDSMP::WndProc(Messages::TMessage &Msg)
{
	if (Msg.Msg==WM_DSMP)
	then {
		Msg.Result=DSMPHandler(Msg.WParam,Msg.LParam);
	}
	else {
		Msg.Result=DefWindowProc(FHandle,Msg.Msg,Msg.WParam,Msg.LParam);
	}
}

/*****	WM_DSMPnh[	*****/

DWORD __fastcall	TDSMP::DSMPHandler(DWORD Event,int Param)
{
	DWORD	res=1;

	DWORD	event=Event;
	if (Event>=0x00010000)
	then	event &=0xFFFF0000;

	switch(event)
	{
		case DSMP_NOTIFY_USER:
			NotifyUser(LOWORD(Event),Param);
			break;
		case DSMP_NOTIFY_OPEN:
			NotifyOpen((HWND)Param);
			break;
		case DSMP_NOTIFY_CLOSE:
			NotifyClose((HWND)Param);
			break;
		case DSMP_NOTIFY_RUN:
			NotifyRun(Param);
			break;
		case DSMP_NOTIFY_ABORT:
			NotifyAbort();
			break;
	}

	if (FEnabled)
	then {
		switch(event)
		{
			case DSMP_NOTIFY_PLAYSTATUS:
				NotifyPlayStatus(Param);
				break;
			case DSMP_NOTIFY_VOLUME:
				NotifyVolume(LOWORD(Param),HIWORD(Param));
				break;
			case DSMP_NOTIFY_LYRICS:
				NotifyLyrics(Param);
				break;
			case DSMP_NOTIFY_COUNTER:
				NotifyCounter(Param);
				break;
			case DSMP_NOTIFY_POSITION:
				NotifyPosition(Param);
				break;
			case DSMP_NOTIFY_TIMER:
				NotifyTimer(Param);
				break;
			case DSMP_NOTIFY_BUTTON:
				NotifyButton(LOWORD(Event),Param);
				break;
			case DSMP_NOTIFY_MENU:
				NotifyMenu(Param);
				break;
			case DSMP_NOTIFY_MOVE:
				NotifyMove((short int)(LOWORD(Param)),(short int)(HIWORD(Param)));
				break;
			case DSMP_NOTIFY_SPEANA:
				NotifySpeana(Event,Param);
				break;
			case DSMP_NOTIFY_STATUS:
				NotifyStatus(LOWORD(Event),Param);
				break;
			case DSMP_NOTIFY_SEND:
				if (FOnReceive)
				then	res=FOnReceive(this,LOWORD(Event),Param);
				break;
		}
	}
	if (FOnDSMP)
	then	FOnDSMP(this,Event,Param);

	return(res);
}

/*****	DSMP_NOTIFY_USER	*****/

void __fastcall	TDSMP::NotifyUser(DWORD Event,int Param)
{
	if (FOnUser)
	then	FOnUser(this,Event,Param);
}

/*****	DSMP_NOTIFY_OPEN	*****/

void __fastcall	TDSMP::NotifyOpen(HWND handle)
{
	FDSMPHandle=handle;

	if ((Enabled==false) AND (FAutoLink))
	then	Bind();

	if (FOnOpen)
	then	FOnOpen(this);
}

/*****	DSMP_NOTIFY_CLOSE	*****/

void __fastcall	TDSMP::NotifyClose(HWND handle)
{
	FDSMPHandle=0;
	Unbind();

	if (FOnClose)
	then	FOnClose(this);
}

/*****	DSMP_NOTIFY_RUN	*****/

void __fastcall	TDSMP::NotifyRun(int id)
{
	FID=id;

	if (FOnRun)
	then	FOnRun(this);
}

/*****	DSMP_NOTIFY_ABORT	*****/

void __fastcall	TDSMP::NotifyAbort(void)
{
	FAborting=true;
	
	if (FOnAbort)
	then	FOnAbort(this);

	FDSMPHandle=0;
	FAborting=false;
	Unbind();
}

/*****	DSMP_NOTIFY_PLAYSTATUS	*****/

void __fastcall	TDSMP::NotifyPlayStatus(int Status)
{
	if (FOnPlayStatus)
	then	FOnPlayStatus(this,Status);
}

/*****	DSMP_NOTIFY_VOLUME	*****/

void __fastcall	TDSMP::NotifyVolume(int L,int R)
{
	if (FOnVolume)
	then	FOnVolume(this,L,R);
}

/*****	DSMP_NOTIFY_SPEANA	*****/

void __fastcall	TDSMP::NotifySpeana(int Param1,int Param2)
{
	int		Level[10];
    int		i;

	if (FOnSpeana)
	then {
		for(i=0;	i<8;	i++)
		{
			Level[i]=Param2 & 0x0F;
			Param2=Param2>>4;
		}
		Level[8]=Param1 & 0x0F;
		Level[9]=(Param1>>4) & 0x0F;
		FOnSpeana(this,Level);
	}
}

/*****	DSMP_NOTIFY_LYRICS	*****/

void __fastcall	TDSMP::NotifyLyrics(int Line)
{
	if (FOnLyrics)
	then	FOnLyrics(this,Line);
}

/*****	DSMP_NOTIFY_COUNTER	*****/

void __fastcall	TDSMP::NotifyCounter(int counter)
{
	if (FOnCounter)
	then	FOnCounter(this,counter);
}

/*****	DSMP_NOTIFY_POSITION	*****/

void __fastcall	TDSMP::NotifyPosition(int ms)
{
	if (FOnPosition)
	then	FOnPosition(this,ms);
}

/*****	DSMP_NOTIFY_TIMER	*****/

void __fastcall	TDSMP::NotifyTimer(int tickcount)
{
	if (FOnIntTimer)
	then	FOnIntTimer(this,tickcount);
}

/*****	DSMP_NOTIFY_MOVE	*****/

void __fastcall	TDSMP::NotifyMove(int Left,int Top)
{
	if (FOnMove)
	then	FOnMove(this,Left,Top);
}

/*****	DSMP_NOTIFY_BUTTON	*****/

void __fastcall	TDSMP::NotifyButton(int Button,int State)
{
	if (FOnButton)
	then	FOnButton(this,Button,State);
}

/*****	DSMP_NOTIFY_MENU	*****/

void __fastcall	TDSMP::NotifyMenu(int Menu)
{
	TDSMPMenu	*menu=GetMenu(Menu);

	if ((menu) AND (menu->OnClick))
	then	menu->OnClick(menu);

	if (FOnMenu)
	then	FOnMenu(menu);
}

/*****	DSMP_NOTIFY_STATUS	*****/

void __fastcall	TDSMP::NotifyStatus(int Status,int Param)
{
	TDSMPMenu	*Menu;

	if (FOnStatus)
	then	FOnStatus(this,Status,Param);

	switch(Status)
	{
		case DSMP_STATUS_VISIBLE:
			if (FOnVisible)
			then	FOnVisible(this,Param);
			break;
		case DSMP_STATUS_ACTIVE:
			if (FOnActive)
			then	FOnActive(this,Param);
			break;
		case DSMP_STATUS_MINIMIZE:
			if (FOnMinimize)
			then	FOnMinimize(this,Param);
			break;
		case DSMP_STATUS_STAYONTOP:
			if (FOnStayOnTop)
			then	FOnStayOnTop(this,Param);
			break;
		case DSMP_STATUS_REPEAT:
			if (FOnRepeat)
			then	FOnRepeat(this,Param);
			break;
		case DSMP_STATUS_RANDOM:
			if (FOnRandom)
			then	FOnRandom(this,Param);
			break;
		case DSMP_STATUS_DISPLAYTIME:
			if (FOnDisplayTime)
			then	FOnDisplayTime(this,Param);
			break;
		case DSMP_STATUS_DISPLAYTRACK:
			if (FOnDisplayTrack)
			then	FOnDisplayTrack(this,Param);
			break;
		case DSMP_STATUS_DISPLAYTITLE:
			if (FOnDisplayTitle)
			then	FOnDisplayTitle(this,Param);
			break;
		case DSMP_STATUS_DISPLAYDEVICE:
			if (FOnDisplayDevice)
			then	FOnDisplayDevice(this,(TDSMPDeviceType)Param);
			break;
		case DSMP_STATUS_DISPLAYCAPTION:
			if (FOnDisplayCaption)
			then	FOnDisplayCaption(this);
			break;
		case DSMP_STATUS_DISPLAYTIMER:
			if (FOnDisplayTimer)
			then	FOnDisplayTimer(this,Param);
			break;
		case DSMP_STATUS_VOLUME:
			if (FOnChangeVolume)
			then	FOnChangeVolume(this,Param);
			break;
		case DSMP_STATUS_OPENTRACK:
			if (FOnOpenTrack)
			then	FOnOpenTrack(this,Param);
			break;
		case DSMP_STATUS_CLOSETRACK:
			if (FOnCloseTrack)
			then	FOnCloseTrack(this,Param);
			break;
		case DSMP_STATUS_SAVEDSMPINI:
			if (FOnSaveDSMPini)
			then	FOnSaveDSMPini(this);
			break;
		case DSMP_STATUS_DESIGN:
			if (FOnDesign)
			then	FOnDesign(this);
			break;
		case DSMP_STATUS_CLICK:
			if (FOnClick)
			then	FOnClick(this,Param);
			break;
		case DSMP_STATUS_DBLCLICK:
			if (FOnDblClick)
			then	FOnDblClick(this,Param);
			break;
		case DSMP_STATUS_DISPLAYMENU:
			if (FOnDisplayMenu)
			then {
				Menu=GetMenu(Param);
				if (Menu)
				then	FOnDisplayMenu(Menu);
			}
			break;
		case DSMP_STATUS_DELETEMENU:
			NotifyDeleteMenu(Param);
			break;
		case DSMP_STATUS_LOADLYRICS:
			FLyricsList->Clear();
			if (FOnLoadLyrics)
			then	FOnLoadLyrics(this);
			break;
		case DSMP_STATUS_CHANGEPLAYLIST:
			if (FOnChangePlayList)
			then	FOnChangePlayList(this,Param);
			break;
		case DSMP_STATUS_DISPLAYMODE:
			if (FOnChangeDisplayMode)
			then	FOnChangeDisplayMode(this,(TDSMPDisplayMode)Param);
			break;
		case DSMP_STATUS_MOVED:
			if (FOnMoved)
			then	FOnMoved(this,(short int)(LOWORD(Param)),(short int)(HIWORD(Param)));
			break;
		case DSMP_STATUS_ADJUSTLEVEL:
			if (FOnAdjustLevel)
			then	FOnAdjustLevel(this,Param);
		case DSMP_STATUS_MUTE:
			if (FOnMute)
			then	FOnMute(this,Param);
			break;
		case DSMP_STATUS_ZOOM:
			if (FOnZoom)
			then	FOnZoom(this,Param);
	}
}

/*****	DSMP_STATUS_DELETEMENU	*****/

void __fastcall	TDSMP::NotifyDeleteMenu(long Handle)
{
	TDSMPMenu	*Menu;
	int			i;

	if (FMenuList)
	then {
		for(i=0;	i<FMenuList->Count;	i++)
		{
			Menu=(TDSMPMenu*)(FMenuList->Items[i]);
			if (Menu->DSMPHandle==Handle)
			then {
				FMenuList->Delete(i);
				delete	Menu;
			}
		}
	}
}

/*****	DSMPN	*****/

bool __fastcall	TDSMP::Execute(AnsiString Param)
{
	if (FDSMPPath.IsEmpty())
	then	return(false);

	if (!Param.IsEmpty())
	then {
		AnsiString	S=FDSMPPath+" ";
		Param=S+Param;
	}

	AnsiString			DirPath=ExtractFileDir(FDSMPPath);
	char*				CurDir=NULL;
	if (!DirPath.IsEmpty())
	then	CurDir=DirPath.c_str();

	STARTUPINFO			si;
	PROCESS_INFORMATION	pi;

	ZeroMemory(&si,sizeof(STARTUPINFO));
	ZeroMemory(&pi,sizeof(PROCESS_INFORMATION));
	si.cb=sizeof(STARTUPINFO);
	si.dwFlags=STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	si.wShowWindow=SW_SHOWNORMAL;

	if (::CreateProcess(FDSMPPath.c_str(),Param.c_str(),NULL,NULL,FALSE,0,NULL,CurDir,&si,&pi)==false)
	then	return(false);

	if (WaitForInputIdle(GetCurrentProcess(),INFINITE))
	then	return(false);

	return(true);
}

/*****	DSMPI	*****/

void __fastcall	TDSMP::Close(void)
{
	if (FEnabled)
	then	DSMPControl->Close();
}

/*****	vOC̃A{[gv	*****/

void __fastcall	TDSMP::Abort(void)
{
	if (FEnabled)
	then	DSMPControl->Abort((long)Handle);
}

/*****	Vbg_E	*****/

void __fastcall	TDSMP::ShutDown(void)
{
	if (FEnabled)
	then	DSMPControl->ShutDown();
}

/*****	DSMP̃EBhEnh擾	*****/

HWND __fastcall	TDSMP::GetDSMPHandle(void)
{
	FDSMPHandle=::FindWindow("TFormDSMP",NULL);
	if (FDSMPHandle==0)
	then	FDSMPHandle=::FindWindow("TDsmpForm",NULL);

	return(FDSMPHandle);
}

/*****	DSMPɃ|Xg	*****/
/*
	DSMPɃNGXg𑗂
	ʂWM_DSMPőĂ
*/
bool __fastcall	TDSMP::Post(int Command,int WParam,int LParam)
{
	if (FDSMPHandle==0)
	then {
		if (GetDSMPHandle()==0)
		then	return(false);
	}

	if (::PostMessage(FDSMPHandle,Command,WParam,LParam)==false)
	then {
		return(::PostMessage(DSMPHandle,Command,WParam,LParam));
	}
	return(true);
}

/*****	DSMPɃNGXg	*****/
/*
	DSMPɃNGXg
	I܂Ŗ߂炸AʂԂ
*/
int __fastcall	TDSMP::Request(int Command,int WParam,int LParam)
{
	if (GetDSMPHandle()==0)
	then	return(0);

	int		Result;

	if (::SendMessageTimeout(FDSMPHandle,Command,WParam,LParam,SMTO_ABORTIFHUNG | SMTO_BLOCK,3000,(DWORD*)&Result)==FALSE)
	then	return(0);

	return(Result);
}

/*****	DSMP̃NI[v	*****/

void __fastcall	TDSMP::Bind(void)
{
	if (FEnabled)
	then	return;									//I[vς

	if (ComponentState.Contains(csDesigning))
	then	return;

	if (GetDSMPHandle()==0)
	then {
		if (Execute("")==false)					//DSMPNĂȂ΋N
		then	return;
	}
  try {
	HRESULT			hr;
	IUnknown		*iunk;
	IDSMPControl	*dsmpcontrol;
	IDSMPPlayList	*dsmpplaylist;
	IDSMPLyrics		*dsmplyrics;
	IDSMPMenu		*dsmpmenu;

	hr=::CoCreateInstance(CLSID_DSMPControl,NULL,CLSCTX_SERVER,IID_IUnknown,(void**)&iunk);
	if (FAILED(hr))
	then {
		AnsiString	S;
		S=Format("DSMPControl Create Instance Error[%x]",OPENARRAY(TVarRec,(((int)hr))));
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}
	hr=iunk->QueryInterface(IID_IDSMPControl,(void**)&dsmpcontrol);
	if (FAILED(hr))
	then {
		AnsiString	S;
		S=Format("IDSMPControl Interface Error[%x]",OPENARRAY(TVarRec,(((int)hr))));
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}
	hr=iunk->QueryInterface(IID_IDSMPPlayList,(void**)&dsmpplaylist);
	if (FAILED(hr))
	then {
		AnsiString	S;
		S=Format("IDSMPPlayList Interface Error[%x]",OPENARRAY(TVarRec,(((int)hr))));
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}
	hr=iunk->QueryInterface(IID_IDSMPLyrics,(void**)&dsmplyrics);
	if (FAILED(hr))
	then {
		AnsiString	S;
		S=Format("IDSMPLyrics Interface Error[%x]",OPENARRAY(TVarRec,(((int)hr))));
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}
	hr=iunk->QueryInterface(IID_IDSMPMenu,(void**)&dsmpmenu);
	if (FAILED(hr))
	then {
		AnsiString	S;
		S=Format("IDSMPMenu Interface Error[%x]",OPENARRAY(TVarRec,(((int)hr))));
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}
	if (FDSMPControl)
	then	FDSMPControl->Bind(dsmpcontrol,true);
	else	FDSMPControl=new TCOMIDSMPControl(dsmpcontrol,true);
	if (FDSMPPlayList)
	then	FDSMPPlayList->Bind(dsmpplaylist,true);
	else	FDSMPPlayList=new TCOMIDSMPPlayList(dsmpplaylist,true);
	if (FDSMPLyrics)
	then	FDSMPLyrics->Bind(dsmplyrics,true);
	else	FDSMPLyrics=new TCOMIDSMPLyrics(dsmplyrics,true);
	if (FDSMPMenu)
	then	FDSMPMenu->Bind(dsmpmenu,true);
	else	FDSMPMenu=new TCOMIDSMPMenu(dsmpmenu,true);

	FDSMPHandle=(HWND)FDSMPControl->Handle;
	ClearMenuList();
	FEnabled=true;

	if ((Version<DSMP_VERSION)
		OR (CheckVersion(DSMP_COMVERSION)==false))
	then {
		Unbind();

		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg("̃o[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);

		return;
	}
	long	Type;
	DSMPControl->Connect((long)HInstance,(long)::GetCurrentProcessId(),(long)Handle,&Type,(long*)&FID);
	FPluginType=(TPluginType)Type;

	SetEvent(FEvent);

	if (FOnBind)
	then	FOnBind(this);
  }
  catch(EOleSysError& e)
  {
	MessageBeep(MB_ICONEXCLAMATION);
	MessageDlg(e.Message,mtError,TMsgDlgButtons()<<mbOK,0);
  }
}

/*****	DSMP̃NN[Y	*****/

void __fastcall	TDSMP::Unbind(void)
{
	if (FEnabled==false)
	then	return;								//I[vĂȂ

	RemoveMenu(NULL);

	DWORD	event=FEvent;

	DSMPControl->Disconnect((long)Handle);
//	SetEvent(0);
	FEvent=event;

	FEnabled=false;
	FID=0;

//	FDSMPPlayList.Unbind();
//	FDSMPControl.Unbind();

	FDSMPControl->Unbind();
	FDSMPPlayList->Unbind();
	FDSMPLyrics->Unbind();
	FDSMPMenu->Unbind();
	delete	FDSMPControl;
	delete	FDSMPPlayList;
	delete	FDSMPLyrics;
	delete	FDSMPMenu;
	FDSMPControl=NULL;
	FDSMPPlayList=NULL;
	FDSMPLyrics=NULL;
	FDSMPMenu=NULL;

	ClearMenuList();

	if (FOnUnbind)
	then	FOnUnbind(this);
}

/*****	I[gN̐ݒ	*****/

void __fastcall	TDSMP::SetAutoLink(bool f)
{
	FAutoLink=f;

	if ((FAutoLink) AND (FEnabled==false)
		AND (ComponentState.Contains(csDesigning)==false)
		AND (ComponentState.Contains(csLoading)==false)
		AND (ComponentState.Contains(csReading)==false))
	then {
		if (GetDSMPHandle())
		then	Bind();
	}
}

/*****	DSMP Version擾	*****/

int __fastcall	TDSMP::GetVersion(void)
{
	if (FEnabled)
	then	return(DSMPControl->Version);

	return(0);
}

/*****	o[W`FbN	*****/

bool __fastcall	TDSMP::CheckVersion(int ver)
{
	if (FEnabled)
	then {
		if (DSMPControl->CheckVersion(ver)==S_OK)
		then	return(true);
	}
	return(false);
}

/*****	vOCN؂	*****/

bool __fastcall	TDSMP::IsPlugin(void)
{
	if (FPluginType==Dsmp::ptUnknown)
	then {
		AnsiString	S;
		int			i;

		for(i=1;	i<=ParamCount();	i++)
		{
			S=ParamStr(i);
			if (S.AnsiCompareIC("/PLUGIN")==0)
			then	return(true);
		}

		return(false);
	}
	else if (FPluginType==ptCOM)
	then	return(false);

	return(true);
}

/*****	ʒmCxg̎擾	*****/

DWORD __fastcall	TDSMP::GetEvent(void)
{
	if (FEnabled)
	then {
		DWORD	Event;

		DSMPControl->GetEvent((long)Handle,(long*)&Event);

		return(Event);
	}

	return(FEvent);
}

/*****	ʒmCxg̐ݒ	*****/

void __fastcall	TDSMP::SetEvent(DWORD Event)
{
	FEvent=Event;

	if (FEnabled)
	then	DSMPControl->SetEvent((long)Handle,Event);
}

/*****	Cxg̎擾	*****/

TDSMPEventSets __fastcall	TDSMP::GetEvents(void)
{
	TDSMPEventSets	Events;
	DWORD	Event=GetEvent();

	if (Event & DSMP_NOTIFY_VOLUME)
	then	Events=Events<<evVolume;
	if (Event & DSMP_NOTIFY_SPEANA)
	then	Events=Events<<evSpeana;
	if (Event & DSMP_NOTIFY_LYRICS)
	then	Events=Events<<evLyrics;
	if (Event & DSMP_NOTIFY_COUNTER)
	then	Events=Events<<evCounter;
	if (Event & DSMP_NOTIFY_POSITION)
	then	Events=Events<<evPosition;
	if (Event & DSMP_NOTIFY_TIMER)
	then	Events=Events<<evTimer;
	if (Event & DSMP_NOTIFY_MOVE)
	then	Events=Events<<evMove;

	return(Events);
}

/*****	Cxg̐ݒ	*****/

void __fastcall	TDSMP::SetEvents(TDSMPEventSets Events)
{
	DWORD	Event=~(DSMP_NOTIFY_VOLUME | DSMP_NOTIFY_SPEANA | DSMP_NOTIFY_LYRICS
				| DSMP_NOTIFY_COUNTER | DSMP_NOTIFY_POSITION | DSMP_NOTIFY_TIMER | DSMP_NOTIFY_MOVE);

	if (Events.Contains(evVolume))
	then	Event |=DSMP_NOTIFY_VOLUME;
	if (Events.Contains(evSpeana))
	then	Event |=DSMP_NOTIFY_SPEANA;
	if (Events.Contains(evLyrics))
	then	Event |=DSMP_NOTIFY_LYRICS;
	if (Events.Contains(evCounter))
	then	Event |=DSMP_NOTIFY_COUNTER;
	if (Events.Contains(evPosition))
	then	Event |=DSMP_NOTIFY_POSITION;
	if (Events.Contains(evTimer))
	then	Event |=DSMP_NOTIFY_TIMER;
	if (Events.Contains(evMove))
	then	Event |=DSMP_NOTIFY_MOVE;

	SetEvent(Event);
}

/*****	Cxgʒm	*****/

void __fastcall	TDSMP::NotifyEvent(HWND Handle,DWORD Event,int Param)
{
	if (Handle==FHandle)
	then {
		::PostMessage(FHandle,WM_DSMP,Event,Param);
	}
	else if (FEnabled)
	then {
		DSMPControl->NotifyEvent((long)Handle,(long)Event,(long)Param);
	}
	else if (Handle==0)
	then {
		::PostMessage(FHandle,WM_DSMP,Event,Param);
	}
}

/*****	vC[̉ʒu̎擾	*****/

int __fastcall	TDSMP::GetLeft(void)
{
	if (FEnabled)
	then {
		return(DSMPControl->Left);
	}
	return(-1);
}

/*****	vC[̉ʒu̐ݒ	*****/

void __fastcall	TDSMP::SetLeft(int left)
{
	if (FEnabled)
	then {
		DSMPControl->Left=left;
	}
}

/*****	vC[̏cʒu̎擾	*****/

int __fastcall	TDSMP::GetTop(void)
{
	if (FEnabled)
	then {
		return(DSMPControl->Top);
	}
	return(-1);
}

/*****	vC[̏cʒu̐ݒ	*****/

void __fastcall	TDSMP::SetTop(int top)
{
	if (FEnabled)
	then {
		DSMPControl->Top=top;
	}
}

/*****	vC[̎̕擾	*****/

int __fastcall	TDSMP::GetWidth(void)
{
	if (FEnabled)
	then {
		return(DSMPControl->Width);
	}
	return(-1);
}

/*****	vC[̍̎擾	*****/

int __fastcall	TDSMP::GetHeight(void)
{
	if (FEnabled)
	then {
		return(DSMPControl->Height);
	}
	return(-1);
}

/*****	DSMP\Ԃ擾	*****/

bool __fastcall	TDSMP::GetVisible(void)
{
	if (FEnabled)
	then	return(DSMPControl->Visible);

	return(false);
}

/*****	DSMP\Ԃݒ肷	*****/

void __fastcall	TDSMP::SetVisible(bool visible)
{
	if (FEnabled)
	then	DSMPControl->Visible=visible;
}

/*****	tXe[^X擾	*****/

int __fastcall	TDSMP::GetPlayStatus(void)
{
	if (FEnabled)
	then	return(DSMPControl->PlayStatus);

	return(DSMP_PLAYSTATUS_NOTREADY);
}

/*****	gbN擾	*****/

int __fastcall	TDSMP::GetTracks(void)
{
	if (FEnabled)
	then	return((*FDSMPPlayList)->Tracks);

	return(0);
}

/*****	gbNԍ擾	*****/

int __fastcall	TDSMP::GetTrack(void)
{
	if (FEnabled)
	then	return(DSMPControl->Track);

	return(0);
}

/*****	gbNw肷	*****/

void __fastcall	TDSMP::SetTrack(int track)
{
	if (FEnabled)
	then	DSMPControl->Track=track;
}

/*****  tԂ擾	*****/

int	__fastcall	TDSMP::GetLength(void)
{
	if (FEnabled)
	then	return(DSMPControl->Length);

	return(0);
}

/*****	Đʒu擾	*****/

int __fastcall	TDSMP::GetPosition(void)
{
	int	Pos=0;

	if (FEnabled)
	then {
		try {
			Pos=DSMPControl->Position;
		}
		catch(...)
		{
			Unbind();
			Pos=0;
		}
	}
	return(Pos);
}

/*****	Đʒuݒ肷	*****/

void __fastcall	TDSMP::SetPosition(int position)
{
	if (FEnabled)
	then	DSMPControl->Position=position;
}

/*****	{[擾	*****/

int __fastcall	TDSMP::GetVolume(void)
{
	if (FEnabled)
	then	return(DSMPControl->Volume);

	return(0);
}

/*****	{[ݒ肷	*****/

void __fastcall	TDSMP::SetVolume(int volume)
{
	if (FEnabled)
	then	DSMPControl->Volume=volume;
}

/*****	JE^[擾	*****/

int __fastcall	TDSMP::GetCounter(void)
{
	if (FEnabled)
	then	return(DSMPControl->Counter);

	return(0);
}

/*****	JE^[ݒ肷	*****/

void __fastcall	TDSMP::SetCounter(int counter)
{
	if (FEnabled)
	then	DSMPControl->Counter=counter;
}

/*****	fUC擾	*****/

AnsiString __fastcall	TDSMP::GetDesign(void)
{
	if (FEnabled)
	then	return(DSMPControl->Design);

	TIniFile	*File=new TIniFile(ChangeFileExt(FDSMPPath,".ini"));
	AnsiString	S=File->ReadString("DSMP","Design","");
	delete	File;

	if (!S.IsEmpty())
	then {
		AnsiString	CurDir=GetCurrentDir();
		SetCurrentDir(ExtractFileDir(FDSMPPath));
		S=ExpandFileName(S);
		SetCurrentDir(CurDir);
	}
	return(S);
}

/*****	fUCݒ肷	*****/

void __fastcall	TDSMP::SetDesign(AnsiString Design)
{
	if (FEnabled)
	then	DSMPControl->set_Design(WideString(Design).Copy());
	else {
		TIniFile	*File=new TIniFile(ChangeFileExt(FDSMPPath,".ini"));
		File->WriteString("DSMP","Design",Design);
		delete	File;
	}
}

/*****	s[gĐ擾	*****/

bool __fastcall	TDSMP::GetRepeat(void)
{
	if (FEnabled)
	then	return(FDSMPControl->Repeat);

	return(false);
}

/*****	s[gĐݒ肷	*****/

void __fastcall	TDSMP::SetRepeat(bool f)
{
	if (FEnabled)
	then	FDSMPControl->Repeat=f;
}

/*****	_Đ擾	*****/

bool __fastcall	TDSMP::GetRandom(void)
{
	if (FEnabled)
	then	return(FDSMPControl->Random);

	return(false);
}

/*****	_Đݒ肷	*****/

void __fastcall	TDSMP::SetRandom(bool f)
{
	if (FEnabled)
	then	FDSMPControl->Random=f;
}

/*****	~[gԂ擾	*****/

bool __fastcall	TDSMP::GetMute(void)
{
	if (FEnabled)
	then	return(FDSMPControl->Mute);

	return(false);
}

/*****	~[gԂݒ肷	*****/

void __fastcall	TDSMP::SetMute(bool f)
{
	if (FEnabled)
	then	FDSMPControl->Mute=f;
}

/*****	oߎ/c莞ԕ\[h擾	*****/

bool __fastcall	TDSMP::GetRemainTime(void)
{
	if (FEnabled)
	then	return(FDSMPControl->RemainTime);

	return(false);
}

/*****	oߎ/c莞ԕ\[hݒ肷	*****/

void __fastcall	TDSMP::SetRemainTime(bool f)
{
	if (FEnabled)
	then	FDSMPControl->RemainTime=f;
}

/*****	I^C}[̏Ԃ̎擾	*****/

bool __fastcall	TDSMP::GetOnTimer(void)
{
	if (Enabled)
	then	return(FDSMPControl->OnTimer);
	return(false);
}

/*****	I^C}[̏Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetOnTimer(bool f)
{
	if (Enabled)
	then	FDSMPControl->OnTimer=f;
}

/*****	I^C}[̎Ԃ̎擾	*****/

int __fastcall	TDSMP::GetOnTime(void)
{
	if (Enabled)
	then	return(FDSMPControl->OnTime);
	return(0);
}

/*****	I^C}[̎Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetOnTime(int time)
{
	if (Enabled)
	then	FDSMPControl->OnTime=time;
}

/*****	It^C}[̏Ԃ̎擾	*****/

bool __fastcall	TDSMP::GetOffTimer(void)
{
	if (Enabled)
	then	return(FDSMPControl->OffTimer);
	return(false);
}

/*****	It^C}[̏Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetOffTimer(bool f)
{
	if (Enabled)
	then	FDSMPControl->OffTimer=f;
}

/*****	I^C}[̎Ԃ̎擾	*****/

int __fastcall	TDSMP::GetOffTime(void)
{
	if (Enabled)
	then	return(FDSMPControl->OffTime);
	return(0);
}

/*****	I^C}[̎Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetOffTime(int time)
{
	if (Enabled)
	then	FDSMPControl->OffTime=time;
}

/*****	Vbg_E(Play)̏Ԃ̎擾	*****/

bool __fastcall	TDSMP::GetShutDownPlay(void)
{
	if (Enabled)
	then	return(FDSMPControl->ShutDownPlay);
	return(false);
}

/*****	Vbg_E(Play)̏Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetShutDownPlay(bool f)
{
	if (Enabled)
	then	FDSMPControl->ShutDownPlay=f;
}

/*****	Vbg_E(Record)̏Ԃ̎擾	*****/

bool __fastcall	TDSMP::GetShutDownRecord(void)
{
	if (Enabled)
	then	return(FDSMPControl->ShutDownRecord);
	return(false);
}

/*****	Vbg_E(Record)̏Ԃ̐ݒ	*****/

void __fastcall	TDSMP::SetShutDownRecord(bool f)
{
	if (Enabled)
	then	FDSMPControl->ShutDownRecord=f;
}

/*****	^x̎擾	*****/

int __fastcall	TDSMP::GetRecLevel(void)
{
	if (Enabled)
	then	return(FDSMPControl->RecLevel);
	return(100);
}

/*****	^x̐ݒ	*****/

void __fastcall	TDSMP::SetRecLevel(int n)
{
	if (Enabled)
	then	FDSMPControl->RecLevel=n;
}

/*****	Đx̎擾	*****/

int __fastcall	TDSMP::GetRate(void)
{
	if (Enabled)
	then	return(FDSMPControl->Rate);

	return(100);
}

/*****	Đx̐ݒ	*****/

void __fastcall	TDSMP::SetRate(int n)
{
	if (Enabled)
	then	FDSMPControl->Rate=n;
}

/*****	ʕ\x̎擾	*****/

int __fastcall	TDSMP::GetAdjustVolLevel(void)
{
	if (Enabled)
	then	return(FDSMPControl->AdjustVolLevel);

	return(100);
}

/*****	ʕ\x̐ݒ	*****/

void __fastcall	TDSMP::SetAdjustVolLevel(int n)
{
	if (Enabled)
	then	FDSMPControl->AdjustVolLevel=n;
}

/*****	XyAi\x̎擾	*****/

int __fastcall	TDSMP::GetAdjustSpeanaLevel(void)
{
	if (Enabled)
	then	return(FDSMPControl->AdjustSpeanaLevel);

	return(100);
}

/*****	XyAi\x̐ݒ	*****/

void __fastcall	TDSMP::SetAdjustSpeanaLevel(int n)
{
	if (Enabled)
	then	FDSMPControl->AdjustSpeanaLevel=n;
}

/*****	̎/XyAi\[h̎擾	*****/

TDSMPDisplayMode __fastcall	TDSMP::GetDisplayMode(void)
{
	if (FEnabled)
	then	return(FDSMPControl->DisplayMode);

	return(dsmpDispNone);
}

/*****	̎/XyAi\[h̐ݒ	*****/

void __fastcall	TDSMP::SetDisplayMode(TDSMPDisplayMode Mode)
{
	if (FEnabled)
	then	FDSMPControl->DisplayMode=Mode;
}

/*****	Audio/Video^Cv̎擾	*****/

TDSMPDeviceType __fastcall	TDSMP::GetAudioVideo(void)
{
	if (FEnabled)
	then	return(FDSMPControl->AudioVideo);

	return(dsmpUnknown);
}

/*****	\{̎擾	*****/

int __fastcall	TDSMP::GetZoom(void)
{
	if (Enabled)
	then	return(FDSMPControl->Zoom);

	return(100);
}

/*****	\{̐ݒ	*****/

void __fastcall	TDSMP::SetZoom(int n)
{
	if (Enabled)
	then	FDSMPControl->Zoom=n;
}

/*****	ŒrfIEBhETCY(Widthj̎擾	*****/

int __fastcall	TDSMP::GetFixedVideoWidth(void)
{
	if (Enabled)
	then	return(FDSMPControl->FixedVideoWidth);

	return(640);
}

/*****	ŒrfIEBhETCY(Widthj̐ݒ	*****/

void __fastcall	TDSMP::SetFixedVideoWidth(int n)
{
	if (Enabled)
	then	FDSMPControl->FixedVideoWidth=n;
}

/*****	ŒrfIEBhETCY(Heightj̎擾	*****/

int __fastcall	TDSMP::GetFixedVideoHeight(void)
{
	if (Enabled)
	then	return(FDSMPControl->FixedVideoHeight);

	return(480);
}

/*****	ŒrfIEBhETCY(Heightj̐ݒ	*****/

void __fastcall	TDSMP::SetFixedVideoHeight(int n)
{
	if (Enabled)
	then	FDSMPControl->FixedVideoHeight=n;
}

/*****	StayOnTop̎擾	*****/

bool __fastcall	TDSMP::GetStayOnTop(void)
{
	if (Enabled)
	then	return(FDSMPControl->StayOnTop);
	return(false);
}

/*****	StayOnTop̐ݒ	*****/

void __fastcall	TDSMP::SetStayOnTop(bool f)
{
	if (Enabled)
	then	FDSMPControl->StayOnTop=f;
}

/*****	Eject	*****/

void __fastcall	TDSMP::Eject(void)
{
	if (FEnabled)
	then	DSMPControl->Eject();
}

/*****	Stop	*****/

void __fastcall	TDSMP::Stop(void)
{
	if (FEnabled)
	then	DSMPControl->Stop();
}

/*****	Pause	*****/

void __fastcall	TDSMP::Pause(void)
{
	if (FEnabled)
	then	DSMPControl->Pause();
}

/*****	Play	*****/

void __fastcall	TDSMP::Play(void)
{
	if (FEnabled)
	then	DSMPControl->Play();
}

/*****	FF	*****/

void __fastcall	TDSMP::FF(bool Down)
{
	if (FEnabled)
	then	DSMPControl->FF(Down);
}

/*****	Rewind	*****/

void __fastcall	TDSMP::Rewind(bool Down)
{
	if (FEnabled)
	then	DSMPControl->Rewind(Down);
}

/*****	Back	*****/

void __fastcall	TDSMP::Back(void)
{
	if (FEnabled)
	then	DSMPControl->Back();
}

/*****	Next	*****/

void __fastcall	TDSMP::Next(void)
{
	if (FEnabled)
	then	DSMPControl->Next();
}

/*****	NbN	*****/

void __fastcall	TDSMP::Click(int ID)
{
	if (FEnabled)
	then	DSMPControl->ClickControl(ID);
}

/*****	L[	*****/

void __fastcall	TDSMP::KeyDown(WORD Key,TShiftState Shift)
{
	if (FEnabled)
	then {
		DSMPControl->KeyDown((short)Key,*((char *)&Shift));
	}
}

/*****	V[N	*****/

void __fastcall	TDSMP::Seek(int track,int position)
{
	if (FEnabled)
	then	DSMPControl->Seek(track,position);
}

/*****	j[̕\	*****/

void __fastcall	TDSMP::ShowMenu(void)
{
	if (FEnabled)
	then	DSMPControl->ShowMenu();
}

/*****	c[j[̕\	*****/

void __fastcall	TDSMP::ShowToolMenu(void)
{
	if (FEnabled)
	then	DSMPControl->ShowToolMenu();
}

/*****	vCXg̕\	*****/

void __fastcall	TDSMP::ShowPlayList(void)
{
	if (FEnabled)
	then	DSMPControl->ShowPlayList();
}

/*****	vpeB̕\	*****/

void __fastcall	TDSMP::ShowProperty(void)
{
	if (FEnabled)
	then	DSMPControl->ShowProperty();
}

/*****	{[[^[̎擾	*****/

void __fastcall	TDSMP::GetVolumes(int *L,int *R)
{
	if (FEnabled)
	then {
		DSMPControl->GetVolume((long*)L,(long*)R);
	}
	else {
		*L=0;
		*R=0;
	}
}

/*****	XyAi̎擾	*****/

void __fastcall	TDSMP::GetSpeana(int *Value)
{
	if (FEnabled)
	then {
		DSMPControl->GetSpeana(
			(long*)&Value[0],
			(long*)&Value[1],
			(long*)&Value[2],
			(long*)&Value[3],
			(long*)&Value[4],
			(long*)&Value[5],
			(long*)&Value[6],
			(long*)&Value[7],
			(long*)&Value[8],
			(long*)&Value[9]);
	}
	else {
		int		i;
		for(i=0;	i<10;	i++)
		{
			Value[i]=0;
		}
	}
}

/*****	DSMP.INĨZ[u	*****/

void __fastcall	TDSMP::SaveDSMPini(void)
{
	if (FEnabled)
	then	FDSMPControl->SaveDSMPini();
}

/*****	vCXg̃NA	*****/

void __fastcall	TDSMP::New(void)
{
	if (FEnabled)
	then	(*FDSMPPlayList)->New();
}

/*****	gbN̒ǉ	*****/

void __fastcall	TDSMP::Add(AnsiString FileName)
{
	if (FEnabled)
	then	(*FDSMPPlayList)->Add(WideString(FileName).Copy());
}

/*****	vCXg/tt@C̃[h	*****/

void __fastcall	TDSMP::Load(AnsiString FileName)
{
	if (FEnabled)
	then	(*FDSMPPlayList)->Load(WideString(FileName).Copy());
}

/*****	vCXg̃Z[u	*****/

void __fastcall	TDSMP::Save(AnsiString FileName)
{
	if (FEnabled)
	then	(*FDSMPPlayList)->Save(WideString(FileName).Copy());
}

/*****	c[݂邩؂	*****/

bool __fastcall	TDSMP::ToolExists(AnsiString Name)
{
	bool		f=false;;
	AnsiString	S=ChangeFileExt(FDSMPPath,".ini");
	TIniFile	*File=new TIniFile(S);

	if (File->ValueExists("Tool",Name))
	then	f=true;

	delete	File;

	return(f);
}

/*****	c[ݒ肷	*****/

void __fastcall	TDSMP::SetTool(AnsiString Name,AnsiString Command)
{
	AnsiString	S=ChangeFileExt(FDSMPPath,".ini");
	TIniFile	*File=new TIniFile(S);

	File->WriteString("Tool",Name,Command);

	delete	File;

	Post(WM_DSMP,DSMP_SETTOOL,0);
}

/*****	c[폜	*****/

void __fastcall	TDSMP::DeleteTool(AnsiString Name)
{
	AnsiString	S=ChangeFileExt(FDSMPPath,".ini");
	TIniFile	*File=new TIniFile(S);

	File->DeleteKey("Tool",Name);

	delete	File;

	Post(WM_DSMP,DSMP_SETTOOL,0);
}

/*****	\̉̎擾	*****/

TLyrics*	__fastcall	TDSMP::GetText(void)
{
	if (FEnabled)
	then {
		TDSMPLyrics	dsmpLyr;

		FDSMPControl->GetText(
			&dsmpLyr.Text,
			&dsmpLyr.Alignment,
			(VARIANT_BOOL*)&dsmpLyr.WordWrap,
			(VARIANT_BOOL*)&dsmpLyr.ShowAccelChar,
			&dsmpLyr.FontName,
			&dsmpLyr.Charset,
			&dsmpLyr.Size,
			&dsmpLyr.Style,
			&dsmpLyr.Color,
			&dsmpLyr.BackColor);
		FText->Set(dsmpLyr);
	}

	return(FText);
}

/*****	̎̍s̎擾	*****/

TLyrics* __fastcall	TDSMP::GetLyricsText(int Line)
{
	return(FLyricsList->Items[Line]);
}

/*****	gbN̎擾	****/

TTrackInfo __fastcall	TDSMP::GetTrackInfo(int track)
{
	if (FEnabled)
	then {
		return(FPlayList->Items[track]);
	}
	else {
		TTrackInfo		TrackInfo;

		return(TrackInfo);
	}
}

/*****	gbN̐ݒ	****/

void __fastcall	TDSMP::SetTrackInfo(int track,TTrackInfo Info)
{
	if (FEnabled)
	then {
		FPlayList->Items[track]=Info;
	}
}

/*****	j[Xg̃NA	*****/

void __fastcall	TDSMP::ClearMenuList(void)
{
	int		i;
	TDSMPMenu	*Menu;

	if (FMenuList)
	then {
		for(i=0;	i<FMenuList->Count;	i++)
		{
			Menu=(TDSMPMenu*)(FMenuList->Items[i]);
			if (Menu)
			then	delete	Menu;
		}
		FMenuList->Clear();
	}
}

/*****	j[̎擾	*****/

TDSMPMenu* __fastcall	TDSMP::GetMenu(long Handle)
{
	int			i;
	TDSMPMenu	*Menu;

	if (Handle==0)
	then	return(NULL);

	if (Handle==DSMP_MENU_PLAYER)
	then	return(FPlayerMenu);
	if (Handle==DSMP_MENU_PLAYLIST)
	then	return(FPlayListMenu);
	if (Handle==DSMP_MENU_PLAYLISTPOPUP)
	then	return(FPlayListPopupMenu);
	if (Handle==DSMP_MENU_TOOL)
	then	return(FToolMenu);

	if (FMenuList)
	then {
		for(i=0;	i<FMenuList->Count;	i++)
		{
			Menu=(TDSMPMenu*)(FMenuList->Items[i]);
			if (Menu->DSMPHandle==Handle)
			then	return(Menu);
		}

		Menu=new TDSMPMenu(this,Handle);
		FMenuList->Add(Menu);

		return(Menu);
	}

	return(NULL);
}

/*****	Xg烁j[폜	*****/

TDSMPMenu* __fastcall	TDSMP::RemoveMenu(TDSMPMenu *Menu)
{
	int		i;
	TDSMPMenu	*menu;

	if (FMenuList)
	then {
		for(i=0;	i<FMenuList->Count;	i++)
		{
			menu=(TDSMPMenu*)(FMenuList->Items[i]);
			if ((menu==Menu) OR (Menu==NULL))
			then {
				FMenuList->Delete(i);
				if (Menu==NULL)
				then	delete	menu;

				return(menu);
			}
		}
	}
	return(NULL);
}

/*****	j[폜	*****/

void __fastcall	TDSMP::DeleteMenu(TDSMPMenu *Menu)
{
	if (RemoveMenu(Menu))
	then {
		if (Menu)
		then	delete	Menu;
	}
}

/*****	Rg[̐F擾	*****/

TColor __fastcall	TDSMP::GetColor(int ID)
{
	if (FEnabled)
	then {
		TColor	Color;
		FDSMPControl->GetColor(ID,(long*)&Color);
		return(Color);
	}
	else	return(clNone);
}

/*****	Rg[̃tHg̎擾	*****/

TFont* __fastcall	TDSMP::GetFont(int ID)
{
	if (FEnabled)
	then {
		BSTR 			FontName;
		long 			Charset;
		long 			Size;
		TDSMPFontStyle	Style;
		long 			Color;

		FDSMPControl->GetFont(ID,&FontName,&Charset,&Size,&Style,&Color);

		FFont->Name=FontName;
		FFont->Charset=(TFontCharset)Charset;
		if (Size<0)
		then	FFont->Height=Size;
		else	FFont->Size=Size;
		FFont->Style=FFont->Style.Clear();
		if (Style & dsmpBold)
		then	FFont->Style=FFont->Style<<fsBold;
		if (Style & dsmpItalic)
		then	FFont->Style=FFont->Style<<fsItalic;
		if (Style & dsmpUnderline)
		then	FFont->Style=FFont->Style<<fsUnderline;
		if (Style & dsmpStrikeOut)
		then	FFont->Style=FFont->Style<<fsStrikeOut;
		FFont->Color=(TColor)Color;
	}

	return(FFont);
}

/*****	vC[̃C[W擾	*****/

void __fastcall	TDSMP::GetFormImage(AnsiString Path)
{
	if (Enabled)
	then	FDSMPControl->GetFormImage(WideString(Path).Copy());
}

/*****	vOC̎擾	*****/

AnsiString __fastcall	TDSMP::GetPluginName(DWORD Handle)
{
	if (Enabled)
	then {
		BSTR	Name=0;
		
		DSMPControl->GetPluginName((long)Handle,(BSTR*)&Name);

		return(Name);
	}

	return("");
}

/*****	vOC̐ݒ	*****/

void __fastcall	TDSMP::SetPluginName(AnsiString Name)
{
	if (FEnabled)
	then	DSMPControl->SetPluginName((long)FHandle,WideString(Name).Copy());
}

/*****	vOČ	*****/

bool __fastcall	TDSMP::FindPlugin(AnsiString Name,HWND *Handle,HINSTANCE *Instance)
{
	if (FEnabled)
	then {
		HWND		handle;
		HINSTANCE	instance;

		DSMPControl->FindPlugin(WideString(Name).Copy(),(long*)&handle,(long*)&instance);
		if (Handle)
		then	*Handle=handle;
		if (Instance)
		then	*Instance=instance;

		if ((handle==NULL) AND (instance==NULL))
		then	return(false);

		return(true);
	}

	return(false);
}

/*****	vOCɑM	*****/

DWORD __fastcall	TDSMP::SendPlugin(DWORD Handle,WORD Cmd,DWORD Param)
{
	DWORD	res=0;

	if (FEnabled)
	then {
		DSMPControl->SendPlugin(Handle,Cmd,Param,&res);
	}

	return(res);
}

/*****	End	*****/

