/*	Filename:DSMP.h								*/
/************************************************/
/*												*/
/*				DSMPC^[tF[X			*/
/*												*/
/*					Ver.6.32   					*/
/*												*/
/*			DSMPC^[tF[XW[		*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef DSMPH
#define DSMPH

#include	"DSMPCOM.H"

namespace Dsmp
{

#if	(__BORLANDC__>=0x560)
typedef	VARIANT_BOOL	TCOMBOOL;
#else
typedef	TOLEBOOL	TCOMBOOL;
#endif

class	TDSMP;

/*----------------------------------------------*/
/*				TTrackInfoNX				*/
/*----------------------------------------------*/

class	TTrackInfo
{
public:
	AnsiString		Title;
	AnsiString		Artist;
	AnsiString		FileName;
	AnsiString		ArcName;
	AnsiString		Lyrics;
	int				Adjust;
	long			Length;
	long			Time;
	TDSMPDeviceType	Device;
	int				Drive;
	int				Track;
	int				Prev;
	int				Next;
	long			Tag;									//User

	TTrackInfo& __fastcall	Set(const TTrackInfo& rhs);
	TTrackInfo& __fastcall	Set(const TDSMPTrackInfo& rhs);
	TTrackInfo& __fastcall	operator =(const TTrackInfo& rhs)	{return(Set(rhs));}
	TTrackInfo& __fastcall	operator =(const TDSMPTrackInfo& rhs)	{return(Set(rhs));}
	void __fastcall	ToDSMPTrackInfo(TDSMPTrackInfo *Info);

	__fastcall	TTrackInfo(void);
};

/*----------------------------------------------*/
/*				TPlayListNX					*/
/*----------------------------------------------*/

class	TPlayList
{
private:
	TDSMP*	FDSMP;

protected:
	TCOMIDSMPPlayList*	__fastcall	GetInterface(void);
	TTrackInfo __fastcall	GetItems(int Track);
	void __fastcall	SetItems(int Track,TTrackInfo Info);
	int __fastcall	GetTracks(void);
	int __fastcall	GetTrack(void);
	int __fastcall	GetFirst(void);
	int __fastcall	GetLast(void);
	int __fastcall	GetRepeatFrom(void);
	void __fastcall	SetRepeatFrom(int Track);
	int __fastcall	GetRepeatTo(void);
	void __fastcall	SetRepeatTo(int Track);
	bool __fastcall	GetEdited(void);
	void __fastcall	SetEdited(bool f);
	AnsiString __fastcall	GetTitle(void);
	void __fastcall	SetTitle(AnsiString title);
	AnsiString __fastcall	GetDesign(void);
	void __fastcall	SetDesign(AnsiString Path);
	AnsiString __fastcall	GetFileName(void);
	bool __fastcall	IsEnabled(void);
	int __fastcall	GetSelected(void);
	void __fastcall	SetSelected(int Track);
	bool __fastcall	GetVisible(void);
	void __fastcall	SetVisible(bool f);

public:
	__fastcall	TPlayList(TDSMP *Owner);

	void __fastcall	New(void);
	void __fastcall	Insert(int track);
	void __fastcall	Delete(int track);
	void __fastcall	Add(AnsiString Path);
	void __fastcall	Load(AnsiString Path);
	void __fastcall	Save(AnsiString Path);
	void __fastcall	EditLyrics(int track);
	void __fastcall	EditLyrics(AnsiString Path);

	__property	TDSMP*	DSMP={read=FDSMP};
	__property	TCOMIDSMPPlayList*	Interface={read=GetInterface};
	__property	bool	Enabled={read=IsEnabled};
	__property	TTrackInfo	Items[int Track]={read=GetItems,write=SetItems};
	__property	int		Count={read=GetTracks};
	__property	int		Tracks={read=GetTracks};
	__property	AnsiString	FileName={read=GetFileName};
	__property	int		Track={read=GetTrack};
	__property	bool	Edited={read=GetEdited,write=SetEdited};
	__property	AnsiString	Title={read=GetTitle,write=SetTitle};
	__property	AnsiString	Design={read=GetDesign,write=SetDesign};
	__property	int		First={read=GetFirst};
	__property	int		Last={read=GetLast};
	__property	int		RepeatFrom={read=GetRepeatFrom,write=SetRepeatFrom};
	__property	int		RepeatTo={read=GetRepeatTo,write=SetRepeatTo};
	__property	int		Selected={read=GetSelected,write=SetSelected};
	__property	bool	Visible={read=GetVisible,write=SetVisible};
};

/*----------------------------------------------*/
/*				TLyricsNX					*/
/*----------------------------------------------*/

class	TLyrics
{
private:
	TFont			*FFont;

protected:
	void __fastcall	Init(void);
	void __fastcall	SetFont(TFont *Font);

public:
	int				Time;
	AnsiString		Text;
	TAlignment		Alignment;
	bool			WordWrap;
	bool			ShowAccelChar;
	TColor			BackColor;
	long			Tag;									//User

	__fastcall	TLyrics(void);
	__fastcall	TLyrics(TLyrics *Lyr);
	__fastcall	~TLyrics(void);
	void __fastcall	Assign(TLyrics *lyr);
	TLyrics& __fastcall	Set(TLyrics& rhs);
	TLyrics& __fastcall	Set(TDSMPLyrics& rhs);
	TLyrics& __fastcall operator =(TLyrics& rhs);
	TLyrics& __fastcall	operator =(TDSMPLyrics& rhs);
	void __fastcall	ToDSMPLyrics(TDSMPLyrics *Lyr);

	__property	TFont*	Font={read=FFont,write=SetFont};
};

/*----------------------------------------------*/
/*				TLyricsListNX				*/
/*----------------------------------------------*/

class	TLyricsList
{
private:
	TDSMP			*FDSMP;
	TList			*FList;

protected:
	TCOMIDSMPLyrics*	__fastcall	GetInterface(void);
	TLyrics* __fastcall	GetItems(int line);
	void __fastcall	SetItems(int line,TLyrics* Lyr);
	int __fastcall	GetLines(void);
	int __fastcall	GetLine(void);
	bool __fastcall	GetVisible(void);
	bool __fastcall	GetShowAccelChar(void);
	int __fastcall	GetAdjust(void);
	AnsiString __fastcall	GetTitle(void);
	AnsiString __fastcall	GetArtist(void);
	AnsiString __fastcall	GetLyrics(void);
	AnsiString __fastcall	GetMusic(void);
	AnsiString __fastcall	GetPresenter(void);
	AnsiString __fastcall	GetComment(void);
	AnsiString __fastcall	GetFileName(void);
	bool __fastcall	IsEnabled(void);
	int __fastcall	GetWidth(void);
	int __fastcall	GetHeight(void);

public:
	__fastcall	TLyricsList(TDSMP *Owner);
	__fastcall	~TLyricsList();

	void __fastcall	Clear(void);
	void __fastcall	Insert(int Line,TLyrics *Lyr);
	void __fastcall	Add(TLyrics *Add);
	void __fastcall	Delete(int line);
	void __fastcall	Load(AnsiString FileName);

	__property	TDSMP*	DSMP={read=FDSMP};
	__property	TCOMIDSMPLyrics*	Interface={read=GetInterface};
	__property	TLyrics*	Items[int Line]={read=GetItems,write=SetItems};
	__property	int			Count={read=GetLines};
	__property	int			Lines={read=GetLines};
	__property	int			Line={read=GetLine};
	__property	bool		Visible={read=GetVisible};
	__property	bool		ShowAccelChar={read=GetShowAccelChar};
	__property	int			Adjust={read=GetAdjust};
	__property	AnsiString	Title={read=GetTitle};
	__property	AnsiString	Artist={read=GetArtist};
	__property	AnsiString	Lyrics={read=GetLyrics};
	__property	AnsiString	Music={read=GetMusic};
	__property	AnsiString	Presenter={read=GetPresenter};
	__property	AnsiString	Comment={read=GetComment};
	__property	int			Width={read=GetWidth};
	__property	int			Height={read=GetHeight};
	__property	AnsiString	FileName={read=GetFileName};
	__property	bool		Enabled={read=IsEnabled};
};

/*----------------------------------------------*/
/*					TDSMPMenuNX				*/
/*----------------------------------------------*/

class	TDSMPMenu:public TComponent
{
private:
	TDSMP*			FDSMP;
	long			FDSMPHandle;
	TNotifyEvent	FOnClick;
	bool			FMaked;

protected:
	HMENU __fastcall	GetHandle(void);
	int __fastcall	GetMenuIndex(void);
	AnsiString __fastcall	GetCaption(void);
	void __fastcall	SetCaption(AnsiString caption);
	TShortCut __fastcall	GetShortCut(void);
	void __fastcall	SetShortCut(TShortCut Key);
	TDSMPMenu* __fastcall	GetParent(void);
	int __fastcall	GetCount(void);
	TDSMPMenu* __fastcall	GetItem(int Index);
	bool __fastcall	GetEnabled(void);
	void __fastcall	SetEnabled(bool f);
	bool __fastcall	GetChecked(void);
	void __fastcall	SetChecked(bool f);
	bool __fastcall	GetVisible(void);
	void __fastcall	SetVisible(bool f);
	TCOMIDSMPMenu* __fastcall	GetInterface(void);
	bool __fastcall	GetAllocated(void);

public:
	__fastcall	TDSMPMenu(TDSMP *Owner,long Handle);
	__fastcall	~TDSMPMenu(void);

	TDSMPMenu* __fastcall	Add(AnsiString Caption);
	TDSMPMenu* __fastcall	Insert(int Index,AnsiString Caption);
	void __fastcall	Delete(int Index);
	void __fastcall	Remove(TDSMPMenu *Menu);
	TDSMPMenu* __fastcall	Find(AnsiString Caption);
	void __fastcall	Click(void);

	__property	TCOMIDSMPMenu*	Interface={read=GetInterface};
	__property	long		DSMPHandle={read=FDSMPHandle,write=FDSMPHandle};
	__property	HMENU		Handle={read=GetHandle};
	__property  int			MenuIndex={read=GetMenuIndex};
	__property	AnsiString	Caption={read=GetCaption,write=SetCaption};
	__property	TShortCut	ShortCut={read=GetShortCut,write=SetShortCut};
	__property	TDSMPMenu*	Parent={read=GetParent};
	__property	int			Count={read=GetCount};
	__property	TDSMPMenu*	Items[int Index]={read=GetItem};
	__property	bool		Enabled={read=GetEnabled,write=SetEnabled};
	__property	bool		Checked={read=GetChecked,write=SetChecked};
	__property	bool		Visible={read=GetVisible,write=SetVisible};
	__property	bool		Allocated={read=GetAllocated};
	__property	bool		Maked={read=FMaked,write=FMaked};

	__property	TNotifyEvent	OnClick={read=FOnClick,write=FOnClick};
};

/*----------------------------------------------*/
/*					TDSMPNX					*/
/*----------------------------------------------*/

typedef void __fastcall (__closure *TDSMPNotifyEvent)(System::TObject* Sender,DWORD Event,int Param);
typedef void __fastcall (__closure *TDSMPEvent)(System::TObject* Sender,int Param);
typedef void __fastcall (__closure *TDSMPBoolEvent)(System::TObject* Sender,bool Flag);
typedef void __fastcall	(__closure *TDSMPVolumeEvent)(System::TObject* Sender,int Left,int Right);
typedef void __fastcall	(__closure *TDSMPSpeanaEvent)(System::TObject* Sender,int *Level);
typedef	void __fastcall (__closure *TDSMPDeviceEvent)(System::TObject* Sender,TDSMPDeviceType Device);
typedef void __fastcall (__closure *TDSMPMoveEvent)(System::TObject* Sender,int Left,int Top);
typedef void __fastcall (__closure *TDSMPDisplayModeEvent)(System::TObject* Sender,TDSMPDisplayMode Mode);
typedef DWORD __fastcall	(__closure *TDSMPReceiveEvent)(System::TObject* Sender,WORD cmd,DWORD Param);

enum	TPluginType	{ptUnknown,ptCOM,ptEXE,ptDLL};
enum	TDSMPEventSet	{evVolume,evSpeana,evLyrics,evCounter,evPosition,evTimer,evMove};
typedef Set<TDSMPEventSet, evVolume, evMove>  TDSMPEventSets;

class PACKAGE TDSMP : public TComponent
{
private:
	UINT				FWM_DSMP;
	TCOMIDSMPControl*	FDSMPControl;
	TCOMIDSMPPlayList*	FDSMPPlayList;
	TCOMIDSMPLyrics*	FDSMPLyrics;
	TCOMIDSMPMenu*		FDSMPMenu;
	HWND				FDSMPHandle;
	AnsiString			FDSMPPath;
	int					FID;
	TPluginType			FPluginType;
	HWND				FHandle;
	bool				FEnabled;
	bool				FAborting;
	bool				FAutoLink;
	DWORD				FEvent;
	TLyrics*			FText;
	TLyricsList*		FLyricsList;
	TPlayList*			FPlayList;
	TDSMPMenu*			FPlayerMenu;
	TDSMPMenu*			FPlayListMenu;
	TDSMPMenu*			FPlayListPopupMenu;
	TDSMPMenu*			FToolMenu;
	TList*				FMenuList;
	TFont*				FFont;

	bool				FCoInit;

	TDSMPNotifyEvent	FOnDSMP;
	TNotifyEvent		FOnOpen;
	TNotifyEvent		FOnClose;
	TNotifyEvent		FOnRun;
	TNotifyEvent		FOnAbort;
	TDSMPEvent			FOnPlayStatus;
	TDSMPVolumeEvent	FOnVolume;
	TDSMPSpeanaEvent	FOnSpeana;
	TDSMPEvent			FOnLyrics;
	TDSMPEvent			FOnCounter;
	TDSMPEvent			FOnPosition;
	TDSMPEvent			FOnIntTimer;
	TDSMPNotifyEvent	FOnButton;
	TNotifyEvent		FOnMenu;
	TNotifyEvent		FOnBind;
	TNotifyEvent		FOnUnbind;
	TDSMPMoveEvent		FOnMove;
	TDSMPMoveEvent		FOnMoved;
	TDSMPNotifyEvent	FOnStatus;
	TDSMPBoolEvent		FOnVisible;
	TDSMPBoolEvent		FOnActive;
	TDSMPBoolEvent		FOnMinimize;
	TDSMPBoolEvent		FOnStayOnTop;
	TDSMPBoolEvent		FOnRepeat;
	TDSMPBoolEvent		FOnRandom;
	TDSMPBoolEvent		FOnDisplayTime;
	TDSMPEvent			FOnDisplayTrack;
	TDSMPEvent			FOnDisplayTitle;
	TDSMPDeviceEvent	FOnDisplayDevice;
	TNotifyEvent		FOnDisplayCaption;
	TDSMPEvent			FOnDisplayTimer;
	TDSMPEvent			FOnChangeVolume;
	TDSMPEvent			FOnOpenTrack;
	TDSMPEvent			FOnCloseTrack;
	TNotifyEvent		FOnSaveDSMPini;
	TNotifyEvent		FOnDesign;
	TDSMPEvent			FOnClick;
	TDSMPEvent			FOnDblClick;
	TNotifyEvent		FOnDisplayMenu;
	TDSMPNotifyEvent	FOnUser;
	TNotifyEvent		FOnLoadLyrics;
	TDSMPEvent			FOnChangePlayList;
	TDSMPDisplayModeEvent	FOnChangeDisplayMode;
	TDSMPEvent			FOnAdjustLevel;
	TDSMPBoolEvent		FOnMute;
	TDSMPEvent			FOnZoom;
	TDSMPReceiveEvent	FOnReceive;

protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual	DWORD __fastcall	DSMPHandler(DWORD Event,int Param);
	HWND __fastcall	GetDSMPHandle(void);
	void __fastcall	NotifyUser(DWORD Event,int Param);
	void __fastcall	NotifyOpen(HWND handle);
	void __fastcall	NotifyClose(HWND handle);
	void __fastcall	NotifyRun(int id);
	void __fastcall	NotifyAbort(void);
	void __fastcall	NotifyPlayStatus(int Status);
	void __fastcall	NotifyVolume(int L,int R);
	void __fastcall	NotifySpeana(int Param1,int Param2);
	void __fastcall	NotifyLyrics(int Line);
	void __fastcall	NotifyCounter(int counter);
	void __fastcall	NotifyPosition(int ms);
	void __fastcall	NotifyTimer(int tickcount);
	void __fastcall	NotifyButton(int Button,int State);
	void __fastcall	NotifyMenu(int Menu);
	void __fastcall	NotifyMove(int Left,int Top);
	void __fastcall	NotifyStatus(int Status,int Param);
	void __fastcall	NotifyDeleteMenu(long Handle);
	int __fastcall	GetVersion(void);
	bool __fastcall	CheckVersion(int ver);
	DWORD __fastcall	GetEvent(void);
	void __fastcall	SetEvent(DWORD Event);
	TDSMPEventSets __fastcall	GetEvents(void);
	void __fastcall	SetEvents(TDSMPEventSets Events);
	int __fastcall	GetLeft(void);
	void __fastcall	SetLeft(int left);
	int __fastcall	GetTop(void);
	void __fastcall	SetTop(int top);
	int __fastcall	GetWidth(void);
	int __fastcall	GetHeight(void);
	bool __fastcall	GetVisible(void);
	void __fastcall	SetVisible(bool visible);
	int __fastcall	GetPlayStatus(void);
	int __fastcall	GetTracks(void);
	int __fastcall	GetTrack(void);
	void __fastcall	SetTrack(int track);
	int __fastcall	GetLength(void);
	int __fastcall	GetPosition(void);
	void __fastcall	SetPosition(int position);
	int __fastcall	GetVolume(void);
	void __fastcall	SetVolume(int volume);
	AnsiString __fastcall	GetDesign(void);
	void __fastcall	SetDesign(AnsiString Design);
	int __fastcall	GetCounter(void);
	void __fastcall	SetCounter(int counter);
	bool __fastcall	GetRepeat(void);
	void __fastcall	SetRepeat(bool f);
	bool __fastcall	GetRandom(void);
	void __fastcall	SetRandom(bool f);
	bool __fastcall	GetMute(void);
	void __fastcall	SetMute(bool f);
	bool __fastcall	GetRemainTime(void);
	void __fastcall	SetRemainTime(bool f);
	bool __fastcall	GetOnTimer(void);
	void __fastcall	SetOnTimer(bool f);
	int __fastcall	GetOnTime(void);
	void __fastcall	SetOnTime(int time);
	bool __fastcall	GetOffTimer(void);
	void __fastcall	SetOffTimer(bool f);
	int __fastcall	GetOffTime(void);
	void __fastcall	SetOffTime(int time);
	bool __fastcall	GetShutDownPlay(void);
	void __fastcall	SetShutDownPlay(bool f);
	bool __fastcall	GetShutDownRecord(void);
	void __fastcall	SetShutDownRecord(bool f);
	void __fastcall	SetAutoLink(bool f);
	TLyrics*	__fastcall	GetText(void);
	TLyricsList* __fastcall	GetLyricsList(void)	{return(FLyricsList);}
	TPlayList* __fastcall	GetPlayList(void)	{return(FPlayList);}
	TTrackInfo __fastcall	GetTrackInfo(int track);
	void __fastcall	SetTrackInfo(int track,TTrackInfo Info);
	TLyrics* __fastcall	GetLyricsText(int Line);
	void __fastcall	ClearMenuList(void);
	TDSMPDisplayMode __fastcall	GetDisplayMode(void);
	void __fastcall	SetDisplayMode(TDSMPDisplayMode Mode);
	int __fastcall	GetRecLevel(void);
	void __fastcall	SetRecLevel(int n);
	TColor __fastcall	GetColor(int ID);
	TFont* __fastcall	GetFont(int ID);
	int __fastcall	GetRate(void);
	void __fastcall	SetRate(int n);
	int __fastcall	GetAdjustVolLevel(void);
	void __fastcall	SetAdjustVolLevel(int n);
	int __fastcall	GetAdjustSpeanaLevel(void);
	void __fastcall	SetAdjustSpeanaLevel(int n);
	int __fastcall	GetZoom(void);
	void __fastcall	SetZoom(int n);
	int __fastcall	GetFixedVideoWidth(void);
	void __fastcall	SetFixedVideoWidth(int n);
	int __fastcall	GetFixedVideoHeight(void);
	void __fastcall	SetFixedVideoHeight(int n);
	TDSMPDeviceType __fastcall	GetAudioVideo(void);
	bool __fastcall	GetStayOnTop(void);
	void __fastcall	SetStayOnTop(bool f);

public:
	__fastcall	TDSMP(TComponent *AOwner);
	__fastcall	~TDSMP(void);
	bool __fastcall	Execute(AnsiString Param);
	bool __fastcall	Post(int Command,int WParam,int LParam);
	int __fastcall	Request(int Command,int WParam,int LParam);
	void __fastcall	Bind(void);
	void __fastcall	Unbind(void);
	void __fastcall	NotifyEvent(HWND Handle,DWORD Event,int Param);
	void __fastcall	Abort(void);
	void __fastcall	Close(void);
	void __fastcall	ShutDown(void);
	void __fastcall	Stop(void);
	void __fastcall	Pause(void);
	void __fastcall	Play(void);
	void __fastcall	FF(bool Down);
	void __fastcall	Rewind(bool Down);
	void __fastcall	Back(void);
	void __fastcall	Next(void);
	void __fastcall	Eject(void);
	void __fastcall	Click(int ID);
	void __fastcall	KeyDown(WORD Key,TShiftState Shift);
	void __fastcall	Seek(int track,int position);
	void __fastcall	ShowMenu(void);
	void __fastcall	ShowPlayList(void);
	void __fastcall	ShowProperty(void);
	void __fastcall	ShowToolMenu(void);
	void __fastcall	GetVolumes(int *L,int *R);
	void __fastcall	GetSpeana(int *Value);
	void __fastcall	SaveDSMPini(void);
	void __fastcall	New(void);
	void __fastcall	Add(AnsiString FileName);
	void __fastcall	Load(AnsiString FileName);
	void __fastcall	Save(AnsiString FileName);
	bool __fastcall	ToolExists(AnsiString Name);
	void __fastcall	SetTool(AnsiString Name,AnsiString Command);
	void __fastcall	DeleteTool(AnsiString Name);
	TDSMPMenu* __fastcall	GetMenu(long Handle);
	TDSMPMenu* __fastcall	RemoveMenu(TDSMPMenu *Menu);
	void __fastcall	DeleteMenu(TDSMPMenu *Menu);
	bool __fastcall	IsPlugin(void);
	void __fastcall	GetFormImage(AnsiString Path);
	AnsiString __fastcall	GetPluginName(DWORD Handle);
	void __fastcall	SetPluginName(AnsiString Name);
	bool __fastcall	FindPlugin(AnsiString Name,HWND *Handle,HINSTANCE *Instance);
	DWORD __fastcall	SendPlugin(DWORD Handle,WORD Cmd,DWORD Param);

	__property	UINT	WM_DSMP={read=FWM_DSMP};
	__property	TCOMIDSMPControl*	DSMPControl={read=FDSMPControl};
	__property	TCOMIDSMPPlayList*	DSMPPlayList={read=FDSMPPlayList};
	__property	TCOMIDSMPLyrics*	DSMPLyrics={read=FDSMPLyrics};
	__property	TCOMIDSMPMenu*		DSMPMenu={read=FDSMPMenu};
	__property	AnsiString	DSMPPath={read=FDSMPPath,write=FDSMPPath};
	__property	HWND	DSMPHandle={read=GetDSMPHandle};
	__property	int		ID={read=FID};
	__property  TPluginType PluginType={read=FPluginType};
	__property	int		Version={read=GetVersion};
	__property	bool	Visible={read=GetVisible,write=SetVisible};
	__property	HWND	Handle={read=FHandle};
	__property	bool	Enabled={read=FEnabled};
	__property	DWORD	Event={read=GetEvent,write=SetEvent};
	__property	int	Left={read=GetLeft,write=SetLeft};
	__property	int	Top={read=GetTop,write=SetTop};
	__property	int	Width={read=GetWidth};
	__property	int	Height={read=GetHeight};
	__property	int	PlayStatus={read=GetPlayStatus};
	__property	int	Tracks={read=GetTracks};
	__property	int	Track={read=GetTrack,write=SetTrack};
	__property	int	Length={read=GetLength};
	__property	int	Position={read=GetPosition,write=SetPosition};
	__property	int	Volume={read=GetVolume,write=SetVolume};
	__property	int	Counter={read=GetCounter,write=SetCounter};
	__property	bool	Repeat={read=GetRepeat,write=SetRepeat};
	__property	bool	Random={read=GetRandom,write=SetRandom};
	__property	bool	Mute={read=GetMute,write=SetMute};
	__property	bool	RemainTime={read=GetRemainTime,write=SetRemainTime};
	__property	bool	OnTimer={read=GetOnTimer,write=SetOnTimer};
	__property	int		OnTime={read=GetOnTime,write=SetOnTime};
	__property	bool	OffTimer={read=GetOffTimer,write=SetOffTimer};
	__property	int		OffTime={read=GetOffTime,write=SetOffTime};
	__property	bool	ShutDownPlay={read=GetShutDownPlay,write=SetShutDownPlay};
	__property	bool	ShutDownRecord={read=GetShutDownRecord,write=SetShutDownRecord};
	__property	AnsiString	Design={read=GetDesign,write=SetDesign};
	__property	TLyrics	*Text={read=GetText};
	__property	TLyricsList	*LyricsList={read=GetLyricsList};
	__property	TPlayList* PlayList={read=GetPlayList};
	__property	TTrackInfo	TrackInfo[int track]={read=GetTrackInfo,write=SetTrackInfo};
	__property	TLyrics*	LyricsText[int Line]={read=GetLyricsText};
	__property	TColor		Color[int id]={read=GetColor};
	__property	TFont*		Font[int id]={read=GetFont};
	__property	TDSMPMenu*	PlayerMenu={read=FPlayerMenu};
	__property	TDSMPMenu*	PlayListMenu={read=FPlayListMenu};
	__property	TDSMPMenu*	PlayListPopupMenu={read=FPlayListPopupMenu};
	__property	TDSMPMenu*	ToolMenu={read=FToolMenu};
	__property	TDSMPDisplayMode	DisplayMode={read=GetDisplayMode,write=SetDisplayMode};
	__property	int		RecLevel={read=GetRecLevel,write=SetRecLevel};
	__property	int		Rate={read=GetRate,write=SetRate};
	__property	int		AdjustVolLevel={read=GetAdjustVolLevel,write=SetAdjustVolLevel};
	__property	int		AdjustSpeanaLevel={read=GetAdjustSpeanaLevel,write=SetAdjustSpeanaLevel};
	__property	int		Zoom={read=GetZoom,write=SetZoom};
	__property	int		FixedVideoWidth={read=GetFixedVideoWidth,write=SetFixedVideoWidth};
	__property	int		FixedVideoHeight={read=GetFixedVideoHeight,write=SetFixedVideoHeight};
	__property	TDSMPDeviceType	AudioVideo={read=GetAudioVideo};
	__property	bool	StayOnTop={read=GetStayOnTop,write=SetStayOnTop};

__published:
	__property	bool	AutoLink={read=FAutoLink,write=SetAutoLink,default=true};
	__property	TDSMPEventSets	Events={read=GetEvents,write=SetEvents};

	__property	TDSMPNotifyEvent	OnDSMP={read=FOnDSMP,write=FOnDSMP};
	__property	TNotifyEvent	OnOpen={read=FOnOpen,write=FOnOpen};
	__property	TNotifyEvent	OnClose={read=FOnClose,write=FOnClose};
	__property	TNotifyEvent	OnRun={read=FOnRun,write=FOnRun};
	__property	TNotifyEvent	OnAbort={read=FOnAbort,write=FOnAbort};
	__property	TDSMPEvent	OnPlayStatus={read=FOnPlayStatus,write=FOnPlayStatus};
	__property	TDSMPVolumeEvent	OnVolume={read=FOnVolume,write=FOnVolume};
	__property	TDSMPSpeanaEvent	OnSpeana={read=FOnSpeana,write=FOnSpeana};
	__property	TDSMPEvent		OnLyrics={read=FOnLyrics,write=FOnLyrics};
	__property	TDSMPEvent		OnCounter={read=FOnCounter,write=FOnCounter};
	__property	TDSMPEvent		OnPosition={read=FOnPosition,write=FOnPosition};
	__property	TDSMPEvent		OnIntTimer={read=FOnIntTimer,write=FOnIntTimer};
	__property	TDSMPNotifyEvent	OnButton={read=FOnButton,write=FOnButton};
	__property	TNotifyEvent	OnMenu={read=FOnMenu,write=FOnMenu};
	__property	TNotifyEvent	OnBind={read=FOnBind,write=FOnBind};
	__property	TNotifyEvent	OnUnbind={read=FOnUnbind,write=FOnUnbind};
	__property	TDSMPMoveEvent	OnMove={read=FOnMove,write=FOnMove};
	__property	TDSMPMoveEvent	OnMoved={read=FOnMoved,write=FOnMoved};
	__property	TDSMPNotifyEvent	OnStatus={read=FOnStatus,write=FOnStatus};
	__property	TDSMPBoolEvent	OnVisible={read=FOnVisible,write=FOnVisible};
	__property	TDSMPBoolEvent	OnActive={read=FOnActive,write=FOnActive};
	__property	TDSMPBoolEvent	OnMinimize={read=FOnMinimize,write=FOnMinimize};
	__property	TDSMPBoolEvent	OnStayOnTop={read=FOnStayOnTop,write=FOnStayOnTop};
	__property	TDSMPBoolEvent	OnRepeat={read=FOnRepeat,write=FOnRepeat};
	__property	TDSMPBoolEvent	OnRandom={read=FOnRandom,write=FOnRandom};
	__property	TDSMPBoolEvent	OnDisplayTime={read=FOnDisplayTime,write=FOnDisplayTime};
	__property	TDSMPEvent	OnChangeVolume={read=FOnChangeVolume,write=FOnChangeVolume};
	__property	TDSMPEvent	OnDisplayTrack={read=FOnDisplayTrack,write=FOnDisplayTrack};
	__property	TDSMPEvent	OnDisplayTitle={read=FOnDisplayTitle,write=FOnDisplayTitle};
	__property	TDSMPDeviceEvent	OnDisplayDevice={read=FOnDisplayDevice,write=FOnDisplayDevice};
	__property	TNotifyEvent	OnDisplayCaption={read=FOnDisplayCaption,write=FOnDisplayCaption};
	__property	TDSMPEvent	OnDisplayTimer={read=FOnDisplayTimer,write=FOnDisplayTimer};
	__property	TDSMPEvent	OnOpenTrack={read=FOnOpenTrack,write=FOnOpenTrack};
	__property	TDSMPEvent	OnCloseTrack={read=FOnCloseTrack,write=FOnCloseTrack};
	__property	TNotifyEvent	OnSaveDSMPini={read=FOnSaveDSMPini,write=FOnSaveDSMPini};
	__property	TNotifyEvent	OnDesign={read=FOnDesign,write=FOnDesign};
	__property	TDSMPEvent	OnClick={read=FOnClick,write=FOnClick};
	__property	TDSMPEvent	OnDblClick={read=FOnDblClick,write=FOnDblClick};
	__property	TNotifyEvent	OnDisplayMenu={read=FOnDisplayMenu,write=FOnDisplayMenu};
	__property	TDSMPNotifyEvent	OnUser={read=FOnUser,write=FOnUser};
	__property	TNotifyEvent	OnLoadLyrics={read=FOnLoadLyrics,write=FOnLoadLyrics};
	__property	TDSMPEvent	OnChangePlayList={read=FOnChangePlayList,write=FOnChangePlayList};
	__property	TDSMPDisplayModeEvent	OnChangeDisplayMode={read=FOnChangeDisplayMode,write=FOnChangeDisplayMode};
	__property	TDSMPEvent	OnAdjustLevel={read=FOnAdjustLevel,write=FOnAdjustLevel};
	__property	TDSMPBoolEvent	OnMute={read=FOnMute,write=FOnMute};
	__property	TDSMPEvent	OnZoom={read=FOnZoom,write=FOnZoom};
	__property	TDSMPReceiveEvent	OnReceive={read=FOnReceive,write=FOnReceive};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

};	//namespace

using  namespace Dsmp;

#endif

/******	End	*****/
